<?php
GUIFactory::setMainGUI("shell");


$TAG = "tabext";

$CONTENTIDS = "22422";

$DRYRUN = true;


$sql = "SELECT c.id construct_id, p.keyword, p.id part_id, p.type_id
        FROM construct c
        LEFT JOIN part p ON p.construct_id = c.id
        WHERE c.keyword like '".sqlf_escaped($TAG)."' AND p.keyword = 'td.header'";

$rs = query($sql);

if (!$rs["num"]) {
 die("no td.header to update!");
}


$cids = "-1";
$pids = "-1";

$pidarray = array();

foreach ($rs["arr"] as $row) {
 $cids .= ",".sqlf_tl_num($row["construct_id"]);
 $pids .= ",".sqlf_tl_num($row["part_id"]);
 $pidarray[$row["construct_id"]]["pid"] = $row["part_id"];
 $pidarray[$row["construct_id"]]["tid"] = $row["type_id"];
 $cidarray[$row["part_id"]] = $row["construct_id"];
}


$sql = "SELECT id, name, construct_id, content_id FROM contenttag WHERE construct_id IN ($cids) AND name REGEXP '".sqlf_escaped($TAG)."[0-9]\$'";
if ($CONTENTIDS) {
 $sql .= " AND content_id IN ($CONTENTIDS)";
}

$rs = query($sql);

echo "<pre>";
foreach ($rs["arr"] as $row) {

 $keyword = $row["name"];
 $content_id = $row["content_id"];
 $construct_id = $row["construct_id"];
 $table_ctid = $row["id"];

 echo "updating table $keyword in content_id $content_id\n";

 
 $sql = "SELECT id, name, construct_id, content_id FROM contenttag WHERE content_id = ".sqlf_tl_num($content_id)." AND name LIKE '".sqlf_escaped($keyword)."._1'";
 $rss = query($sql);

 
 foreach ($rss["arr"] as $rrow) {
 $ctid = $rrow["id"];
 $ctname = $rrow["name"];
 $tagname = $ctname.".style";
 $type_id = $pidarray[$construct_id]["tid"];
 $part_id = $pidarray[$construct_id]["pid"];

 $value = "p${part_id}_a";
 global $$value;
 $$value = 1;

 if ($DRYRUN === false) {
 $tag_id = tag_create($tagname,$content_id,"content",$construct_id,0,1,$table_ctid);
 
 
 part_update($part_id,$type_id,$construct_id,1,"content",$tag_id,0);
 } else {
 $tag_id = "dryrun!";
 }
 echo "updated $tagname (tag_id:$tag_id)\n";
 }
 echo "\n";
}
?>
