<?php



$restrict = "";
$maingui =& GUIFactory::setMainGUI( "main" );
$maingui->includeJS("jquery-1.6.1.min");
$maingui->excludeJS("jquery");
$maingui->includeJS("jquery.gtxpercent");

load_menu( 301, $T_MAINTENANCE );




$sql = "SELECT node.id id, node.folder_id folder_id, folder.name name FROM node, folder WHERE node.folder_id = folder.id";
$rs = query($sql);

$node_infos = array();


if ($rs["arr"]) {
 while (list($key,$val) = each($rs["arr"])) {
 if (perm($USER_ID,$T_DOMAIN,$val["folder_id"],0) || perm($USER_ID,$T_DOMAIN_CHANNEL,$val["folder_id"],0)) {
 $node_infos[$val["id"]] = $val;
 }
 }
}


if (sizeof($node_infos) == 0) {
 $restrict = "1 = 2";
 $channel_restrict = "1 = 2";
} else {
 $restrict = "node.id IN (".implode(",", sqlf_value_array(array_keys($node_infos))).")";
 $channel_restrict = "channel_id in (".implode(",", sqlf_value_array(array_keys($node_infos))).")";
}






function executeTool( &$form, $param ) {
 global $restrict, $FEATURE, $node_infos, $USER_ID, $T_MAINTENANCE;

 if (!perm($USER_ID,$T_MAINTENANCE,"",2)) {
 return;
 }

 $type_comp =& $form->resolveComponent("main.type");
 $tools =& $form->resolveComponent("main.tools");
 $nodeComponent =& $form->resolveComponent("main.node");
 $status =& $form->resolveComponent("status");
 $tool = $tools->getSingleSelection();
 $node = $nodeComponent->getSingleSelection();
 $type_sel = $type_comp->getSelection();

 if ($tool == "stop_publishing") {
 node_class("codeparser");
 node_class("nodefactory");
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->stopPublish();
 } else if ($tool == "reload_config") {
 node_class("codeparser");
 node_class("nodefactory");
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->reloadConfig();
 } else {
 
 $types = array();
 foreach ( $type_sel as $type ) {
 if ($type) {
 $types[] = $type;
 }
 }
 
 if (count($types) == 0) {
 $type_comp->addError(new NodeException(i18n("maintenance_must_select_type")));
 return;
 }

 
 $crComponent =& $form->resolveComponent("main.contentrepository");
 $contentrepository = $crComponent->getSingleSelection();
 
 if ($contentrepository != -1 && $contentrepository != "all") {
 $sql = "SELECT id FROM node WHERE contentrepository_id != ".sqlf_tl_num($contentrepository)." OR contentrepository_id IS NULL";
 $rs = query($sql);
 while (list($key, $val) = each($rs["arr"])) {
 unset($node_infos[$val["id"]]);
 }
 }

 
 $rangeSelectComponent =& $form->resolveComponent("main.rangeselect");
 $range = $rangeSelectComponent->getSingleSelection();
 $rangeStartComponent =& $form->resolveComponent("main.rangeStart");
 $rangeEndComponent =& $form->resolveComponent("main.rangeEnd");
 $rangeStart = $rangeStartComponent->getTimestamp();
 $rangeEnd = $rangeEndComponent->getTimestamp();

 if( $range == 'creation' ) {
 $range = 'cdate';
 } else {
 $range = NULL;
 }

 $modified = array();
 if ($node == -1 || $node == "all") {
 
 if (count($node_infos) == 0) {
 $nodeComponent->addError(new NodeException(i18n("No Node met your restrictions")));
 $crComponent->addError(new NodeException(i18n("No Node met your restrictions")));
 return;
 }
 $modified[] = implode("|", array_keys($node_infos));
 } else {
 if (!$node_infos[$node]) {
 $nodeComponent->addError(new NodeException(i18n("No Node met your restrictions")));
 $crComponent->addError(new NodeException(i18n("No Node met your restrictions")));
 return;
 }
 $modified[] = $node;
 }
 if ($range) {
 $modified[] = $range;
 $modified[] = $rangeStart;
 $modified[] = $rangeEnd;
 }

 switch ($tool) {
 case "republish_objects":
 if ($modified[0] != "") {
 foreach ( $types as $type ) {
 triggerEvent($type, "0", EVENT_MAINTENANCE_PUBLISH, new EventObject(null, $modified));
 logcmd(W_MAINTENANCE, $type, 0, 0, "Republish");
 }
 $status->setText( i18n( "maintenance_republish_objects_description" )."<br/>".i18n("maintenance_description"));
 }
 break;
 case "delay_objects":
 if ($modified[0] != "") {
 foreach ( $types as $type ) {
 triggerEvent($type, "0", EVENT_MAINTENANCE_DELAY, new EventObject(null, $modified));
 logcmd(W_MAINTENANCE, $type, 0, 0, "Delay publish");
 }
 $status->setText( i18n( "maintenance_delay_objects_description" )."<br/>".i18n("maintenance_description"));
 }
 break;
 case "republish_delayed":
 if ($modified[0] != "") {
 foreach ( $types as $type ) {
 triggerEvent($type, "0", EVENT_MAINTENANCE_REPUBLISH, new EventObject(null, $modified));
 logcmd(W_MAINTENANCE, $type, 0, 0, "Republish delayed objects");
 }
 $status->setText( i18n( "maintenance_republish_delayed_description" )."<br/>".i18n("maintenance_description"));
 }
 break;
 case "mark_objects_published":
 if ($modified[0] != "") {
 foreach ( $types as $type ) {
 triggerEvent($type, "0", EVENT_MAINTENANCE_MARKPUBLISHED, new EventObject(null, $modified));
 logcmd(W_MAINTENANCE, $type, 0, 0, "Mark objects published");
 }
 $status->setText( i18n( "maintenance_mark_objects_published_description" )."<br/>".i18n("maintenance_description"));
 }
 break;
 }
 }
}

$form = new HtmlForm3("settings");
if ($form->isNew()) {
 node_class("listcomponent");
 node_class("textcomponent");
 node_class("labelcomponent");
 node_class("radiolistcomponent");
 node_class("datecomponent");
 node_class("calendarcomponent");

 $main = new ListComponent();

 $tools = array(
 "republish_objects" => i18n("maintenance_republish_objects"),
 "delay_objects" => i18n("maintenance_delay_objects"),
 "republish_delayed" => i18n("maintenance_republish_delayed"),
 "mark_objects_published" => i18n("maintenance_mark_objects_published"),
 "stop_publishing" => i18n("stop publishing"),
 "reload_config" => i18n("maintenance_reload_config"));
 $main->setComponent("tools", new RadioListComponent(i18n("Tools"), $tools));

 $type_options = array("10007" => i18n("Pages"), "10008" => i18n("Images")."/".i18n("Files"), "10002" => i18n("Folders"));
 $main->setComponent("type", $comp = new SelectComponent(i18n("Type"), $type_options));
 $comp->enableMultipleSelect(3);
 $comp->setAllowEmpty(false);




 $node_options = array();
 $node_options["all"] = '[ ' . i18n("All Nodes") . ' ]';
 $sql = "SELECT node.id AS id, folder.name AS name FROM node INNER JOIN folder ON node.folder_id = folder.id WHERE $restrict ORDER BY folder.name";
 $rs = query( $sql );
 while( list( $key, $value ) = each( $rs["arr"] ) ) {
 $node_options[$value["id"]] = $value["name"];
 }

 $selectNode = new SelectComponent( i18n( "Node" ),
 $node_options);
 $selectNode->setAllowEmpty(false);
 $main->setComponent("node", $selectNode);

 $cr_options = array();
 $cr_options["all"] = '[ ' . i18n("All ContentRepositories") . ' ]';
 $crs = ContentRepository::getSelectOptions(" order by name");
 while(list($key, $val) = each($crs)) {
 $cr_options[$key] = $val;
 }

 $selectCR = new SelectComponent( i18n("ContentRepository"), $cr_options);
 $selectCR->setAllowEmpty(false);
 $main->setComponent("contentrepository", $selectCR);

 $rangeSelect = new SelectComponent( i18n( "Limit to date range" ),
 array( 'none' => i18n( "None" ),
 'creation' => i18n( "Creation Date")), 'none' );
 $main->setComponent('rangeselect', $rangeSelect );

 $rangeStart = new DateComponent( i18n( "Range Start" ), false, DCP_DATETIME );
 $main->setComponent("rangestart", $rangeStart);

 $rangeEnd = new DateComponent( i18n( "Range End" ), false, DCP_DATETIME );
 $main->setComponent("rangeend", $rangeEnd);

 $form->setHeader(i18n("Maintenance Tools"));
 $form->addComponent("main",$main);

 $form->addButton("execute", new Button(i18n("Execute Tool")), new SimpleFormAction("executeTool"), true);

 $statusLabel = new LabelComponent(null, "", true );
 $form->addComponent("status", $statusLabel );

 $dirtQueueLabel = new LabelComponent(i18n("dirtqueue_entries"), "", true);
 $form->addComponent("dirtqueue", $dirtQueueLabel);
}


updateObjectSums($form);


updateDirtQueueEntries($form);





function updateObjectSums(&$form) {
 global $restrict, $channel_restrict, $help;

 
 $help = "<table>";

 $help .= "<tr><td colspan=3><i>*".i18n("maintenance_deactivated_nodes_notice")."</i></td></tr>";
 $help .= "<tr><td colspan=3><hr/></td></tr>";
 $help .= getObjectSums(10007, i18n("Pages To Publish"), 0);
 $help .= "<tr><td colspan=3><hr/></td></tr>";
 $help .= getObjectSums(10007, i18n("Pages To Publish Delayed"), 1);
 $help .= "<tr><td colspan=3><hr/></td></tr>";
 $help .= getObjectSums(10008, i18n("maintenance_dirted_files"), 0);
 $help .= "<tr><td colspan=3><hr/></td></tr>";
 $help .= getObjectSums(10008, i18n("maintenance_delayed_files"), 1);
 $help .= "<tr><td colspan=3><hr/></td></tr>";
 $help .= getObjectSums(10002, i18n("maintenance_dirted_folders"), 0);
 $help .= "<tr><td colspan=3><hr/></td></tr>";
 $help .= getObjectSums(10002, i18n("maintenance_delayed_folders"), 1);
 $help .= "<tr><td colspan=3><hr/></td></tr>";
 $help .= "<tr><td colspan=3><i>*".i18n("maintenance_deactivated_nodes_notice")."</i></td></tr>";

 
 $help .= "</table>";
}








function getObjectSums($type, $label, $delay) {
 global $channel_restrict;

 
 $sql = "select count(DISTINCT pq.obj_id) c, channel_id FROM publishqueue pq where pq.action != 'DELETE' AND pq.action != 'HIDE' AND pq.action != 'REMOVE' AND pq.obj_type = " . $type . " AND delay = " . $delay . " and " . $channel_restrict . " group by channel_id";
 $rs = query($sql);

 
 $total_publish = 0;
 while (list($key, $row) = each($rs["arr"])) {
 $total_publish += $row["c"];
 }

 
 $out = "<tr><td><b>$label</b></td><td align=right>".$total_publish."</td><td></td></tr>";

 
 $publish_info = getPercentageList($rs["arr"], $total_publish);
 reset($publish_info);
 while (list($key, $val) = each($publish_info)) {
 $out .= "<tr class=\"percent\"><td>".$val["name"]."</td><td align=right>".$val["c"]."</td><td align=right class=\"percentvalue\" title=\"" . $val["perc_round"] . "\">".$val["perc_round"]." %</td></tr>";
 }

 return $out;
}

function updateDirtQueueEntries(&$form) {
 $dirtQueueLabel =& $form->resolveComponent("dirtqueue");
 $sql = "select events, obj_type, obj_id, property from dirtqueue where failed = 0 order by timestamp asc";
 $rs = query($sql);

 $dirtQueueEntries = "";
 $lastentry = "unset";
 $counter = 0;
 $isfirst = true;

 while (list($key, $val) = each($rs["arr"])) {
 if (isLoggingEvent($val)) {
 continue;
 }
 $currententry = "dirt";
 if (isMaintenanceEvent($val)) {
 $currententry = "maintenance";
 } else if (isCREvent($val)) {
 $currententry = "cr";
 } else if (isPublishEvent($val)) {
 $currententry = "publish";
 }
 if ($lastentry != $currententry) {
 if ($counter > 0) {
 $dirtQueueEntries .= printDirtQueueLine($counter, $lastentry, $isfirst);
 $isfirst = false;
 }
 $counter = 0;
 $lastentry = $currententry;
 }
 ++$counter;
 }

 if ($counter > 0) {
 $dirtQueueEntries .= printDirtQueueLine($counter, $lastentry, $isfirst); 
 }

 if ($dirtQueueEntries == "") {
 $dirtQueueEntries = i18n("dirtqueue_noentries");
 } else {
 $dirtQueueEntries = "<table>$dirtQueueEntries</table>";
 }

 $dirtQueueLabel->setText($dirtQueueEntries);
}

function printDirtQueueLine($counter, $lastentry, $first) {
 return "<tr><td>".($first ? "<b>" : "")."$counter".($first ? "</b>" : "")."</td><td>".($first ? "<b>" : "").i18n("dirtqueue_$lastentry").($first ? "</b>" : "")."</td></tr>";
}

function isMaintenanceEvent($row) {
 $eventmask = $row["events"];
 return (($eventmask & EVENT_MAINTENANCE_PUBLISH) != 0) ||
 (($eventmask & EVENT_MAINTENANCE_DELAY) != 0) ||
 (($eventmask & EVENT_MAINTENANCE_REPUBLISH) != 0) ||
 (($eventmask & EVENT_MAINTENANCE_MARKPUBLISHED) != 0) ||
 (($eventmask & MAINTENANCE_MIGRATE2PUBLISHQUEUE) != 0);
}

function isLoggingEvent($row) {
 $eventmask = $row["events"];
 return (($eventmask & EVENT_LOGGING_START) != 0) ||
 (($eventmask & EVENT_LOGGING_END) != 0);
}

function isPublishEvent($row) {
 return $row["obj_type"] == null && $row["obj_id"] == null && $row["property"] == "publish";
}

function isCREvent($row) {
 $eventmask = $row["events"];
 return ($eventmask & EVENT_DATACHECK_CR) != 0;
}




function getPercentageList($values, $total_number) {
 $temp_sum = 0;
 $perc_list = array();
 $perc_sum = 0;

 if ($values) {
 while (list($key,$val) = each($values)) {
 $perc = $val["c"] * 100 / $total_number;
 $perc_round = round($perc, 1);
 $perc_sum += $perc_round;
 $node = get_nodeinfo($val["channel_id"]);
 $name = $node["name"];
 if ($node["disable_publish"] == 1) {
 $name = "<i>(".$name.")*</i>";
 }
 $temp_arr = array("name" => $name, "perc_round" => $perc_round, "perc" => $perc, "c" => $val["c"]);
 $perc_list[] = $temp_arr; 
 $temp_sum += $val["c"];
 }
 }
 
 if ( $temp_sum < $total_number ) {
 $perc = ($total_number - $temp_sum) * 100 / $total_number;
 $perc_round = round($perc, 1);
 $perc_sum += $perc_round;
 $temp_arr = array("name" => i18n("other"), "perc_round" => $perc_round, "perc" => $perc, "c" => ($total_number - $temp_sum)); 
 $perc_list[] = &$temp_arr;
 }

 if (count($perc_list) == 0) {
 return $perc_list;
 }

 
 while (round($perc_sum, 1) > 100) {
 while ((list ($key, $val) = each($perc_list)) && round($perc_sum, 1) > 100) {
 if ($val["perc_round"] > $val["perc"]) {
 $val["perc_round"] -= 0.1;
 $perc_sum -= 0.1;
 $perc_list[$key] = $val;
 }
 }
 }
 while (round($perc_sum,1) < 100) {
 while ((list ($key, $val) = each($perc_list)) && round($perc_sum,1) < 100) {
 if ($val["perc_round"] < $val["perc"]) {
 $val["perc_round"] += 0.1;
 $perc_sum += 0.1;
 $perc_list[$key] = $val;
 }
 }
 }

 return $perc_list;
}

?>
