<?php

class ImageSelector extends MinibrowserWrapper {

 var $d_mb = NULL;
 var $d_rootType, $d_rootId, $d_imageId;

 function FileSelector ($root_id = 0, $root_type = 0, $image_id = 0) {
 global $T_CONTENT;
 if (!$root_type && !$root_id) {
 $root_type = $T_CONTENT;
 $sql = "SELECT id FROM tree WHERE type_id = ".sqlf_tl_num($T_CONTENT);
 $rs = query($sql);
 $root_id = $rs["arr"][0]["id"];
 }
 $this->d_rootType = $root_type;
 $this->d_rootId = $root_id;
 $this->d_imageId = $image_id;
 }
 
 function getSerializeKey()
 {
 return array(
 "parent"=>parent::getSerializeKey(),
 "mnbr"=>node_serialize( $this->d_mb )
 );
 }
 
 function initFromSerializeKey( $key )
 {
 parent::initFromSerializeKey( $key["parent"] );
 $this->d_mb = &node_unserialize( $key["mnbr"] );
 }
 
 
 function setRoot ($o_id, $o_type) {
 $this->d_mb->setRootID($o_id);
 $this->d_mb->setRootType($o_type);
 }
 
 function setObject(&$obj) {
 if (is_a($obj, "cnimageobject")) {
 $this->setFileID($obj->getID());
 }
 }

 function initObject($type, $id) {
 $this->setFileID($id);
 }

 function getObjectType () {
 global $T_IMAGE;
 return $T_IMAGE;
 }

 function getObjectID() {
 return $this->d_mb->getResultID();
 }

 function setFileID($id) {
 global $T_FOLDER;
 $id = (int) $id;
 $sql = "SELECT folder_id FROM contentfile WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $this->d_mb->setFolder($rs["arr"][0]["folder_id"], $T_FOLDER);
 $this->d_mb->setResultID(1, $id);
 $this->d_mb->setStep(1);
 }
 

 function getFileID() {
 return $this->d_mb->getResultID();
 }

 function &getMinibrowser() {
 $this->createMinibrowser();
 node_var("T_TYPE");
 return $this->d_mb;
 }

 function createMinibrowser () {
 if ( !is_null( $this->d_mb ) ) return;

 
 global $T_FOLDER, $T_NODE, $ICO_IMAGE;
 node_class("minibrowser");
 
 
 node_class( "miniimagedatasource" );
 $ds = new MiniImageDatasource ();
 $ds->setColumn( "name", i18n( "Image" ), true, true );
 $ds->showColumnHeader(true);
 
 $this->d_mb = new MiniBrowser($this->d_rootId, $this->d_rootType);
 $this->d_mb->addType($T_FOLDER);
 $this->d_mb->addType($T_NODE);
 $this->d_mb->addStepDS($ds);
 $this->d_mb->setHeader(i18n("Select Image"));

 if ($this->d_imageId) $this->setImageID($this->d_imageId);

 }

 function getText() {
 $this->createMinibrowser();
 $file = new CNImageObject($this->d_mb->getResultID());
 $name = $file->getProperty("name");
 return $name->toString();
 }

 function getResultObject() {
 $this->createMinibrowser();
 return new CNImageObject($this->d_mb->getResultID());
 }

}


?>
