<?php


echo $fileUploader->getAssetsHtml();
?>

<div id="file_dialog" <?php if ($showMiniBrowser) { ?> style="width: 760px;"<?php } ?>>
	<div<?php if ($showMiniBrowser) { ?> style="width: 460px; float: left; overflow: hidden;"<?php } ?>>
<?php

echo $dialogOutput;
?>
	</div>

<?php
if ($showMiniBrowser) {
?>
	<div style="width: 300px; float: left;">
<?php
$htmlform->pstart();
echo dialog($miniTree->build_form(), "", "normal", i18n("cn_minibrowser"), $ICO_MINI);
$htmlform->pend();
?>
	</div>
<?php
}
?>
</div>

<div style="clear: both;"></div>

<script type="text/javascript">

// Whether to bypass the submit hook
var bypassSubmitHook = false;
var $okButton        = $("input[name=factionok]");
$okButton.attr("onclick", "");

/**
 * Called when a file was uploaded successfully without errors.
 *
 * @param {Object} file         Original plupload file
 * @param {Object} responseFile RestAPI response object
 */
function fileUploader_onSuccess(file, responseFile) {
	var $filetype;

	// Set the file ID
	var $fileIdInput = $("input[name=f_fileid]");
	var $form = $fileIdInput.closest('form');
	$fileIdInput.val(responseFile.id);
 
	// Update the corresponding information
	$(".dialog h1").first().text(responseFile.name);
	$("input[name=f_filename]").val(responseFile.name);
	$("#filesize").text(plupload.formatSize(responseFile.fileSize));

	$filetype = $(".dialog input[name=f_filetype]");
	if ($filetype.length > 0) {
		$filetype.val(responseFile.fileType);
	} else {
		$("#f_filetype").text(responseFile.fileType);
	}

	bypassSubmitHook = true;

	// Call the clientside validation function
	if (!check_gentics(true, $form[0])) {
		restoreOkButton();
		return;
	}

	// Post the form
	$("input[name=factionok]").click();
}

/**
 * Called when an error occured during file upload.
 */
function fileUploader_onError() {
	restoreOkButton();
}

/**
 * Makes the OK-button clickable again.
 */
function restoreOkButton() {
	$okButton
		.css({ opacity: 1.0 })
		.attr("src", "?do=15&text=OK");
}

/**
 * Called when new files have been added to the queue.
 */
function fileUploader_onFilesAdded(files) {
	var file = files[0];
	var $fileNameInput = $("input[name=f_filename]");
	var $filetype = $(".dialog input[name=f_filetype]");

<?php
if ($command === "new") {
?>
	$fileNameInput.val(file.name);
<?php
} else {
?>
	// If the file extension has changed, we have to takeover the new one.
	$fileNameInput.val(correctFileExtension($fileNameInput.val(), file.name));
	createButtonTakeoverFilename($fileNameInput, file.name);

	// Clear the displayed mimetype, as it is unknown at this time
	if ($filetype.length > 0) {
		$filetype.val("");
	} else {
		$("#f_filetype").text("");
	}
<?php
}
?>

	// Update the filesize
	if (file.size !== null && file.size > 0) {
		$("#filesize").text(plupload.formatSize(file.size));
	} else {
		$("#filesize").text("-");
	}
}

/**
  * In case the file extension has changed, this function
  * will correct the file extension in the old filename.
  *
  * @param   {string} oldFileName  The old filename
  * @param   {string} newFileName  The new filename
  * @returns {string}              The new corrected filename
  */
function correctFileExtension(oldFileName, newFileName) {
	var correctedOldFileName = oldFileName;
	var oldFileNameInfo      = fileUploader.getFileNameAndExtension(oldFileName);
	var newFileNameInfo      = fileUploader.getFileNameAndExtension(newFileName);

	// Check if the new filename has an extension and if it
	// differs from the old one
	if (newFileNameInfo.extension !== null
			&& oldFileNameInfo.extension !== newFileNameInfo.extension) {
		correctedOldFileName = oldFileNameInfo.fileName
			+ "." + newFileNameInfo.extension;
	}

	return correctedOldFileName;
}

/**
  * Creates a new button for taking over the filename of
  * a newly uploaded file. By default, the old filename will be kept.
  *
  * @param {Object} $fileNameInput  The jQuery object that holds the file name text input  
  * @param {string} newFileName     The new filename
  */
function createButtonTakeoverFilename($fileNameInput, newFileName) {
	// Detach old button if one exists
	$("#f_takeoverfilename").remove();

	// Create new button for taking over the new filename
	var $takeoverFilenameInput =
		$('<input type="image" id="f_takeoverfilename" border="0" style="vertical-align: -7px;"'
			+ ' src="?do=15&amp;text=<?php echo i18n('fileuploader.newfile.takeoverfilename'); ?>" />');
	// Insert the button after the filename input
	$fileNameInput.parent().append($takeoverFilenameInput);

	// Add an onclick handler for taking over the new filename
	$takeoverFilenameInput.click(function() {
		// Update the filename
		$("input[name=f_filename]").val(newFileName);
		$(this).remove();
	});
}

/**
 * Called on enter and when "OK" is clicked.
 */
function file_onSubmit(event) {
	if (bypassSubmitHook) {
		bypassSubmitHook = false;
		return true;
	}

	// Take over the file name from the user input
	var files = fileUploader.getFiles();
	if (files.length === 1) {
		files[0].name = $("input[name=f_filename]").val();
	}

	// If there is a file in the queue, upload it first
	// and cancel this form
	if (fileUploader.startUpload() > 0) {
		// Change the opacity and the text of the button
		$okButton
			.css({ opacity: 0.5 })
			.attr("src", "?do=15&text=(Uploading...)")
			.attr("onclick", "");

		return false;
	}

	return true;
}

$(document).ready(function() {

	// This implements custom submit event
	// handling for the fileuploader

	// Unset all onclick attributes
	$("input")
		.removeAttr("onkeydown")
		.keydown(function(event) {
			if (event.which === 13) {
				return file_onSubmit(event);
			}
		}
	);

	$okButton
		.removeAttr("onkeydown")
		.click(function(event) {
			return file_onSubmit(event);
		}
	);
});

</script>
