<?php

if ($FEATURE["2dotool_integration"]) {
 node_include('todotool');
}

function cmd_user_create($login, $password, $firstname, $lastname, $description,$email) {
 global $TIME, $USER_ID, $ERROR, $DIC, $W_CREATE, $T_USER, $T_USERADMIN, $FEATURE;

 
 if (!perm($USER_ID,$T_USERADMIN,"",8)) {
 $ERROR = i18n('813.you_have_no_permission_to');
 return false;
 }

 
 $login = strip_tags($login);
 $firstname = strip_tags($firstname);
 $lastname = strip_tags($lastname);
 $email = strip_tags($email);
 
 
 $a_login = sqlslashes($login);
 $sql = "SELECT login FROM systemuser WHERE login='$a_login'";
 $rs = query($sql);
 if ($rs["arr"][0]["login"]) {
 $ERROR = i18n('a_user_with_this_login');
 return false;
 }

 
 $login = sqlslashes($login);
 $firstname = sqlslashes($firstname);
 $lastname = sqlslashes($lastname);
 $description = sqlslashes($description);
 $email = sqlslashes($email);
 
 $sql = "INSERT INTO systemuser (active,login,password,firstname,lastname,description,email,edate,cdate,editor,creator) 
          VALUES (1,'$login','','$firstname','$lastname','$description','$email',".sqlf_tl_num($TIME).",".sqlf_tl_num($TIME).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($USER_ID).")";
 $rs = query($sql);

 $user_id = $rs["iid"];
 
 $password = crypt_pw($user_id,$password);
 $sql = "UPDATE systemuser SET password = '".sqlslashes($password)."' WHERE id = ".sqlf_tl_num($user_id);
 query($sql);

 
 logcmd($W_CREATE, $T_USER, $user_id , 0, "cmd_user_create");
 triggerEvent( T_USER, $user_id, EVENT_CREATE, new EventObject() );
 
 return $user_id;
}

function cmd_user_del($id = 0,$allowed_ids="") {
 global $T_USER, $W_DEL, $USER_ID, $DIC;
 
 if (!$id) halt(0,"cmd_user_del: no user.id to delete");
 $deleted_ids = array();

 $error = 0;

 
 if (is_array($id)) {
 if (!is_array($allowed_ids)) $allowed_ids = user_getuser_list($USER_ID);
 
 while (list($key,$val) = each($id)) {
 
 
 if (!in_array($key,$allowed_ids) || $key == 1) $error++; else {
 $tmp .= " id = ".sqlf_tl_num($key)." OR";
 $tmp1 .= " user_id = ".sqlf_tl_num($key)." OR";
 
 logcmd($W_DEL, $T_USER, $key , 0, "cmd_user_del");
 $deleted_ids[] = $key;
 }
 }
 } else {
 if (!is_array($allowed_ids)) {
 $allow = user_check($USER_ID,$id);
 } else {
 
 
 if (in_array($id,$allowed_ids) || $key != 1) $allow = 1; else $allow = 0;
 }
 if ($allow == 1) {
 $tmp = "id = ".sqlf_tl_num($id)." OR";
 $tmp1 = "user_id = ".sqlf_tl_num($id)." OR";
 
 logcmd($W_DEL, $T_USER, $id , 0, "cmd_user_del");
 $deleted_ids[] = $id;
 } else {
 $error++;
 }
 }

 $sql = "UPDATE systemuser SET active=0, login='' WHERE $tmp 1=2";
 query($sql);

 
 $sql = "DELETE FROM user_group WHERE $tmp1 1=2";
 query($sql);
 
 
 if ($error == 0) $error = false;

 if ($error == 1) $ERROR = i18n('775.a_user_could_not_be'); else $ERROR = $error . i18n('users_could_not_be');

 while (list($key, $val) = each($deleted_ids)) {
 triggerEvent( T_USER, $val, EVENT_DELETE, new EventObject() );
 }
 
 
 return $error;
}

function cmd_user_update($id,$login,$password,$firstname,$lastname,$description,$email) {
 global $TIME, $USER_ID, $DIC, $ERROR, $T_USER, $W_EDIT, $T_USERADMIN;

 
 $login = strip_tags($login);
 $firstname = strip_tags($firstname);
 $lastname = strip_tags($lastname);
 $email = strip_tags($email);
 
 if (!$id) halt(0,"cmd_user_update: no user.id to update");

 $perm = user_check($USER_ID,$id) & perm($USER_ID,$T_USERADMIN,"",9);
 if (!$perm && $USER_ID != $id && $USER_ID != 1) {
 $ERROR = i18n('814.you_have_no_permission_to');
 return false;
 }

 
 $a_login = sqlslashes($login);
 
 $sql = "SELECT id, login FROM systemuser WHERE login='$a_login'";
 $rs = query($sql);
 if ($rs["arr"][0]["login"] && $rs["arr"][0]["id"] != $id) {
 $ERROR = i18n('a_user_with_this_login');
 return false;
 }

 if ($password) {
 $password = sqlslashes(crypt_pw($id,$password));
 $sqladd = " password='$password',";
 } else $sqladd = "";

 
 $login = sqlslashes($login);
 $firstname = sqlslashes($firstname);
 $lastname = sqlslashes($lastname);
 $description = sqlslashes($description);
 $email = sqlslashes($email);

 $modified = array();
 
 if ($perm || $USER_ID == 1) {
 $sql = "SELECT login, firstname, lastname, description, email, edate, editor FROM systemuser WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $olduser = $rs['arr'][0];
 foreach( array('login','firstname','lastname','description','email') as $prop ) {
 if( $olduser[$prop] != $$prop) {
 $modified[] = $prop;
 }
 }
 $sql = "UPDATE systemuser SET login='$login',$sqladd firstname='$firstname',
            lastname='$lastname', description='$description', email='$email', 
            edate = ".sqlf_tl_num($TIME).", editor = ".sqlf_tl_num($USER_ID)." WHERE id = ".sqlf_tl_num($id);
 } elseif ($USER_ID == $id && $password) {
 $sql = "UPDATE systemuser SET password = '".sqlf_escaped($password)."' WHERE id = ".sqlf_tl_num($id);
 } else $sql = "SELECT 1";
 query($sql);

 
 logcmd($W_EDIT, $T_USER, $id , 0, "cmd_user_update");
 if (count($modified) > 0) {
 triggerEvent( T_USER, $id, EVENT_UPDATE, new EventObject(null, $modified) );
 }
 
 return $id;
}

function cmd_user_group_mod($user_id, $group_id, $force = false) {
 global $TIME, $USER_ID, $DIC, $W_EDIT, $T_GROUP, $ERROR;

 

 if (!$user_id) halt(0,"cmd_user_group_mod: No user.id to modify group-conn");

 if ($group_id) {
 
 if (is_array($group_id)) {
 
 arsort($group_id);
 reset($group_id);
 
 while (list($key,$val) = each($group_id)) {
 if ($val) {
 
 if (perm_usergroup($USER_ID,$key,11) && $key != 1 && $key != 2) {

 $sql = "INSERT INTO user_group (usergroup_id, user_id, cdate, creator) VALUES (".sqlf_tl_num($key).", ".sqlf_tl_num($user_id).", ".sqlf_tl_num($TIME).", ".sqlf_tl_num($USER_ID).")";
 query($sql);
 
 logcmd($W_EDIT, $T_GROUP, $key, $user_id, "cmd_user_group_mod");
 } else {
 $ERROR = i18n('the_user_could_not_be');
 }
 } else {
 
 if (user_removecheck($user_id,$key,0,$force)) {
 $sql = "DELETE FROM user_group WHERE usergroup_id = ".sqlf_tl_num($key)." AND user_id = ".sqlf_tl_num($user_id);
 query($sql);
 
 logcmd($W_EDIT, $T_GROUP, $key , "-".$user_id, "cmd_user_group_mod");
 }
 }
 }
 } else {
 if ($val) {
 if (perm_usergroup($USER_ID,$val,11) && $group_id != 1 && $group_id != 2) {
 $sql = "SELECT usergroup_id FROM user_group WHERE user_id = ".sqlf_tl_num($user_id)." AND usergroup_id = ".sqlf_tl_num($group_id);
 $rs = query($sql);
 if ($rs["num"] == 0) {

 $sql = "INSERT INTO user_group (usergroup_id, user_id, cdate, creator) VALUES (".sqlf_tl_num($group_id).", ".sqlf_tl_num($user_id).", ".sqlf_tl_num($TIME).", ".sqlf_tl_num($USER_ID).")";
 query($sql);
 }
 
 logcmd($W_EDIT, $T_GROUP, $group_id, $user_id, "cmd_user_group_mod");
 } else {
 $ERROR = i18n('the_user_could_not_be');
 }
 } else {
 if (user_removecheck($user_id,$key,0,$force)) {
 $sql = "DELETE FROM user_group WHERE usergroup_id = ".sqlf_tl_num($group_id)." AND user_id = ".sqlf_tl_num($user_id);
 query($sql);
 
 logcmd($W_EDIT, $T_GROUP, $group_id, "-".$user_id, "cmd_user_group_mod");
 }
 }
 }
 }

 triggerEvent( T_GROUP, 0, EVENT_UPDATE, new EventObject() );
 
 if ($ERROR) return false; else return $user_id;
}






function user_get_noderestrictions($user_id) {
 $node_restriction = array();
 $sql = "select user_group_node.node_id, user_group.usergroup_id";
 $sql .= " from user_group inner join user_group_node on user_group.id = user_group_node.user_group_id";
 $sql .= " where user_group.user_id = ".sqlf_tl_num($user_id);
 $rs = query($sql);
 foreach ( $rs["arr"] as $row ) {
 $node_restriction[$row["usergroup_id"]][] = $row["node_id"];
 }
 return $node_restriction;
}






function user_set_noderestrictions($user_id, $node_restrictions) {
 
 $nodeIds = getVisibleNodeIds();

 if (count($nodeIds) > 0) {
 
 $allCurrent = user_get_noderestrictions($user_id);
 foreach ( $node_restrictions as $groupId => $nodes ) {
 $current = $allCurrent[$groupId];

 
 $nodes = array_intersect($nodes, $nodeIds);

 $sql = "SELECT id FROM user_group WHERE user_id = ".sqlf_tl_num($user_id)." AND usergroup_id = ".sqlf_tl_num($groupId);
 $rs = query($sql);
 if ($rs["num"] > 0) {
 $userGroupId = $rs["arr"][0]["id"];

 if (!$current) {
 
 if (count($nodes) > 0) {
 $sql = "INSERT INTO user_group_node (user_group_id, node_id) VALUES ";
 $pairs = array();
 foreach ( $nodes as $nodeId ) {
 $pairs[] = "(".sqlf_tl_num($userGroupId).", ".sqlf_tl_num($nodeId).")";
 }
 $sql .= implode(",", $pairs);
 query($sql);
 }
 } else {
 $current = array_intersect($current, $nodeIds);

 
 $toRemove = array_diff($current, $nodes);

 if (count($toRemove) > 0) {
 $sql = "DELETE FROM user_group_node WHERE user_group_id = ".sqlf_tl_num($userGroupId)." AND node_id IN (".implode(",", sqlf_tl_num_array($toRemove)).")";
 query($sql);
 }

 
 $toInsert = array_diff($nodes, $current);

 if (count($toInsert) > 0) {
 $sql = "INSERT INTO user_group_node (user_group_id, node_id) VALUES ";
 $pairs = array();
 foreach ( $toInsert as $nodeId ) {
 $pairs[] = "(".sqlf_tl_num($userGroupId).", ".sqlf_tl_num($nodeId).")";
 }
 $sql .= implode(",", $pairs);
 query($sql);
 }
 }
 }
 }
 }
}






function user_get_groups($user_id) {
 $sql = "SELECT usergroup_id from user_group where user_id=" . ((int)$user_id);
 $rs = query($sql);
 $result = array();

 reset($rs["arr"]);
 while (list(, $value) = each($rs["arr"])) {
 $result[] = $value["usergroup_id"];
 }
 return $result;
}






function user_is_restriction_required() {
 global $USER_ID;
 if ($USER_ID == 1) {
 return false;
 }
 $restrictions = user_get_noderestrictions($USER_ID);
 return count($restrictions) != 0;
}








function validate_node_restrictions($groups, $node_restriction, $luid) {

 if (!user_is_restriction_required()) {
 return array();
 }

 
 $node_restriction = (array)$node_restriction;

 
 if (count($node_restriction) > 0) {
 $node_restriction = array_combine(array_keys($node_restriction), array_values($node_restriction));
 }

 $result = array();
 $current_user_groups = user_get_groups($luid);
 $previous_assignments = user_get_noderestrictions($luid);
 $visibleNodeIds = getVisibleNodeIds();
 $all_groups = array_unique(array_merge($current_user_groups, array_keys($groups)));

 foreach ($all_groups as $index => $groupid) {
 $group_added = isset($groups[$groupid]) && $groups[$groupid] == 1;
 $group_removed = isset($groups[$groupid]) && $groups[$groupid] == 0;
 $group_assignment_exists = in_array($groupid, $current_user_groups);
 $has_prev_node_assignments = array_key_exists($groupid, $previous_assignments)
 && count(array_intersect($previous_assignments[$groupid], $visibleNodeIds)) > 0;
 $has_new_node_assignments = array_key_exists($groupid, $node_restriction)
 && count(array_intersect($node_restriction[$groupid], $visibleNodeIds)) > 0;

 
 $has_new_node_assignments |= (array_key_exists($groupid, $previous_assignments)
 && count(array_diff($previous_assignments[$groupid],$visibleNodeIds)) > 0); 

 if (!$has_new_node_assignments && ($group_added || ($group_assignment_exists && !$group_removed && $has_prev_node_assignments))) {
 $result[]=$groupid;
 }
 }
 return $result;
}






 function formatGroupList($validation_result) {
 reset($validation_result);
 $names = array();
 while(list($key,$value) = each($validation_result)) {
 $ginfo = get_usergroupinfo($value);
 $names[] = $ginfo['name'];
 }
 return implode(", ", $names);
}
?>
