<?php
define("PERM_TASK_TEMPLATE_LIST", 8);

Guifactory::setMainGui("main");

node_include("task_schedule_func");
$NODERELATED[$DO] = getTaskRelated($DO);


$LAST_TASK_VIEW = 1;
load_menu( 852, $T_TASKADMIN, 0, i18n('view_task_templates') );

node_class( "userformatter" );
node_class( "dateformatter" );


if ( perm( $USER_ID, T_TASKADMIN, "", PERM_TASK_TEMPLATE_LIST) == 1 ) {
 $select = "*";
 $from = "tasktemplate";
 $where = "";
 $groupby = "";
} else {
 $select = "*";
 $from = "tasktemplate, perm, user_group";
 $where = "user_group.user_id = ".sqlf_tl_num($USER_ID)." AND perm.usergroup_id = user_group.usergroup_id AND tasktemplate.id = o_id AND o_type = ".sqlf_tl_num(T_TASK_TEMPLATE)." AND perm LIKE \"1%\"";
 $groupby = "o_id";
}

$ds = new SQLDatasource( "tasktemplateds", $select, $from, $where, $groupby);
$ds->setDBHandle( $DB );
$ds->addColumn( "lnkname", i18n( "Name" ), true, "name", "name" );
$ds->addColumn( "description", i18n( "description" ), true, true, true );
$ds->addColumn( "command", i18n( "Command" ), true, true, true );
$ds->makeLink("lnkname", "name", "do=851", "list", "id", "id");
if (perm( $USER_ID, T_TASKADMIN, "", 9) ) {
 $ds->addAction( new CommandAction( $ICO_DELETE, "del", i18n('delete'), "cmd_tasktemplate_del" ) );
}
$ds->addFormatter( "cname", new UserFormatter( "creator", USERINFO_NAME ) );
$ds->addFormatter( "fcdate", new DateFormatter( "cdate" ) );
$ds->addFormatter( "ename", new UserFormatter( "editor", USERINFO_NAME ) );
$ds->addFormatter( "fedate", new DateFormatter( "edate" ) );
$ds->setAss( "<b>" . i18n('sn_task_template') . "</b><br><br><b>".i18n('sn_name')."</b> \$name<br>".
 "<b>" . i18n('845.creator') . ":</b><br>\$fcdate (\$cname)<br>".
 "<b>" . i18n('last_edited') . ":</b><br>\$fedate (\$ename)" );


$list = new ItemList3("task_templates", $ds );
$list->setShowInfo( true );

?>
