<?php

class TaskObject extends SearchableObject {

 var $id = 0;

 function TaskObject($id=0) {
 parent::SearchableObject($id);
 $this->setID($id);
 }

 function _setID($id) {
 $this->id = $id;
 }

 function getID() {
 return $this->id;
 }

 function getTType() {
 return T_TASK;
 }

 function getParentTType() {
 return array(T_TASKADMIN);
 }

 function _getNodeTable() {
 return "task";
 }

 function getValueFields() {
 return array( 'name' => 'text' );
 }

 function getIcon() {
 global $ICO_TASK;
 return $ICO_TASK;
 }

 function _checkPermission($parentObjectType, $parentObjectId) {
 global $USER_ID;
 return perm($USER_ID, $this->getTType(), $this->getID(), 0);
 }

 function _checkSearchTerm($searchTerm) {
 if (! $searchTerm) {
 return true;
 }
 $name = $this->getFieldValue("name");
 if (strpos(strtolower($name), strtolower($searchTerm)) !== FALSE) {
 return true;
 }
 return false;
 }
}

?>
