<?php

function get_sub_events($reaction_id) {
 global $T_WORKFLOWEVENT, $W_EVENT;
 
 $sql = "SELECT id, keyword AS name, ".sqlf_tl_num($T_WORKFLOWEVENT)." AS type FROM triggerevent WHERE reaction_id = ".sqlf_tl_num($reaction_id)." AND templateevent_id = 0";
 $rs = query($sql);
 $rs = $rs["arr"];
 reset($rs);
 while (list($key,$val) = each($rs)) {
 $rs[$key]["name"] = ($W_EVENT[$val["name"]]["name"])?$W_EVENT[$val["name"]]["name"]:$val["name"];
 }
 
 reset($rs);
 return $rs;
}

function get_sub_reactions($event_id) {
 global $T_WORKFLOWREACTION, $W_REACTION;
 
 $sql = "SELECT id, keyword AS name, ".sqlf_tl_num($T_WORKFLOWREACTION)." AS type FROM reaction WHERE triggerevent_id = ".sqlf_tl_num($event_id);
 $rs = query($sql);
 $rs = $rs["arr"];
 reset($rs);
 while (list($key,$val) = each($rs)) {
 $rs[$key]["name"] = ($W_REACTION[$val["name"]]["name"])?$W_REACTION[$val["name"]]["name"]:$val["name"];
 }

 reset($rs);
 return $rs;
}

function get_workflowroot($workflow_id) {
 global $T_WORKFLOWEVENT, $W_EVENT;

 $sql = "SELECT id, keyword AS name, ".sqlf_tl_num($T_WORKFLOWEVENT)." AS type FROM triggerevent WHERE reaction_id = 0 AND workflow_id = ".sqlf_tl_num($workflow_id)." AND templateevent_id = 0";
 $rs = query($sql);
 $rs = $rs["arr"];
 reset($rs);
 while(list($key,$val) = each($rs)) {
 $rs[$key]["name"] = ($W_EVENT[$val["name"]]["name"])?$W_EVENT[$val["name"]]["name"]:$val["name"];
 }
 
 reset($rs);
 return $rs;
}

function get_workflow_objects() {

 global $W_OBJECT, $T_WORKFLOWOBJECT, $T_TYPE;

 $list = array();
 if (is_array($W_OBJECT)) {
 reset($W_OBJECT);
 while (list($key,$name) = each($W_OBJECT)) {

 $arr = array();
 $arr["id"] = $key;
 $arr["name"] = $T_TYPE[$key]["name"];
 $arr["icon"] = $T_TYPE[$key]["folderclosed"];
 $arr["type"] = $T_WORKFLOWOBJECT;
 $list[] = $arr;
 }
 }

 return $list;
}

?>
