var GTXAutoUpdateStatus = {
	
	/**
	 * initialize the AutoUpdateStatus
	 */
	init: function() {
		GTXAutoUpdateStatus.ref = this;
		GTXAutoUpdateStatus.ref.checkStatus();
	},
	
	/**
	 * activate an update phase
	 * @param String current update phase
	 * @param String an error that may have occured 
	 */
	setActivePhase: function(phase, error) {
		var phase;
		var phaseReached = false;
		if (error == "") {
			setTimeout(GTXAutoUpdateStatus.ref.checkStatus, 2000);
		} else {
			alert(error);
		}
		if (phase == "") {
			return false;
		}
		jQuery("#updatestatus").children().each(function(i, o) {
			if (jQuery(this).attr("id") == "updatestatus_" + phase) {
				if (error) {
					jQuery(this).addClass("error");
				} else {
					jQuery(this).addClass("active");
				}
				phaseReached = true;
			} else {
				if (!phaseReached) {
					jQuery(this).removeClass("active");
					jQuery(this).addClass("done");
				}
			}
		});
		
	},
	
	/**
	 * check the current status
	 */
	checkStatus: function() {
		var now = new Date();
		jQuery.getJSON("<?=$STAG;?>&do=1040&cmd=getprogress&ts=" + now.getTime(), null, function(data) {
			GTXAutoUpdateStatus.ref.setActivePhase(data.status, data.error);
		});
	}
}