<?php












































$CACHE_NO_STATIC_CACHE = false;
$CACHE_STATIC_TRANSACT = false;



$CACHE_TMP_CACHE = array();
$CACHE_STATIC_CACHE = array();
$CACHE_STATIC_ACTION = array();
$CACHE_STATIC_RESET = array();

function cache_exists($name,$static=0) {
 global $CACHE, $CACHE_STATIC, $CACHE_NO_STATIC_CACHE, $CACHE_STATIC_TRANSACT, $CACHE_TMP_CACHE, $CACHE_STATIC_CACHE, $CACHE_STATIC_ACTION, $CACHE_STATIC_RESET;
 
 if (!$CACHE) return false;
 if (!$name) halt(7,"cache_exists: not a valid cache name. name($name)");
 
 if (!$static) {
 return isset($CACHE_TMP_CACHE[$name]);
 } elseif (!$CACHE_STATIC) {
 return isset($CACHE_STATIC_CACHE[$name]);
 } else {
 if (isset($CACHE_STATIC_CACHE[$name]) && !$CACHE_NO_STATIC_CACHE) {
 return true;
 } elseif (((is_array($CACHE_STATIC_RESET) && $CACHE_STATIC_RESET[$name]) || (!is_array($CACHE_STATIC_RESET) && $CACHE_STATIC_RESET)) && $CACHE_STATIC_TRANSACT && !$CACHE_NO_STATIC_CACHE) { 
 return false;
 } else {
 $sql = "SELECT count(name) AS c FROM systemcache WHERE name = '".sqlslashes($name)."'";
 $rs = query($sql);
 if ($rs["arr"][0]["c"] > 0) {
 return true;
 } else {
 return false;
 }
 }
 }
 return false;
}

function cache_is_set($name,$key,$static=0) {
 global $CACHE, $CACHE_STATIC, $CACHE_NO_STATIC_CACHE, $CACHE_STATIC_TRANSACT, $CACHE_TMP_CACHE, $CACHE_STATIC_CACHE, $CACHE_STATIC_ACTION, $CACHE_STATIC_RESET;

 if (!$CACHE) return false;
 if (!$name) halt(7,"cache_is_set: not a valid cache name. name($name)");
 if (!$key || is_array($key)) halt(7,"cache_is_set: not a valid key. key($key)");

 if (!$static) {
 return isset($CACHE_TMP_CACHE[$name][$key]);
 } elseif (!$CACHE_STATIC) {
 return isset($CACHE_STATIC_CACHE[$name][$key]);
 } else {
 if (isset($CACHE_STATIC_CACHE[$name][$key]) && !$CACHE_NO_STATIC_CACHE) {
 return true;
 } elseif (((is_array($CACHE_STATIC_RESET) && $CACHE_STATIC_RESET[$name]) || (!is_array($CACHE_STATIC_RESET) && $CACHE_STATIC_RESET) || $CACHE_STATIC_ACTION[$name][$key] == 2) && $CACHE_STATIC_TRANSACT && !$CACHE_NO_STATIC_CACHE) {
 return false;
 } else {
 $sql = "SELECT count(name) AS c FROM systemcache WHERE name = '".sqlslashes($name)."' AND ckey = '".sqlslashes($key)."'";
 $rs = query($sql);
 if ($rs["arr"][0]["c"] == 1) {
 return true;
 } elseif ($rs["arr"][0]["c"] > 1) {
 warning(20,"cache_is_set: multiple values for name($name) key($key).");
 return false;
 } else {
 return false;
 }
 }
 }
 return false;
}

function cache_set($name,$key,$val,$static=0) {
 global $CACHE, $CACHE_STATIC, $CACHE_NO_STATIC_CACHE, $CACHE_STATIC_TRANSACT, $CACHE_TMP_CACHE, $CACHE_STATIC_CACHE, $CACHE_STATIC_ACTION, $CACHE_STATIC_RESET;

 if (!$CACHE) return false;
 if (!$name) halt(7, "cache_set: not a valid name. name($name)");
 if (!$key ||is_array($key)) halt(7,"cache_set: not a valid key. key($key)");

 if (!$static) {
 $b = isset($CACHE_TMP_CACHE[$name][$key]);
 $CACHE_TMP_CACHE[$name][$key] = $val;
 return $b;
 } elseif ($static && !$CACHE_STATIC) {
 $b = isset($CACHE_STATIC_CACHE[$name][$key]);
 $CACHE_STATIC_CACHE[$name][$key] = $val;
 return $b;
 } else {
 if (!$CACHE_NO_STATIC_CACHE) {
 $b = isset($CACHE_STATIC_CACHE[$name][$key]);
 $CACHE_STATIC_CACHE[$name][$key] = $val;
 if ($CACHE_STATIC_TRANSACT) {
 $CACHE_STATIC_ACTION[$name][$key] = 1;
 }
 }
 if ($CACHE_NO_STATIC_CACHE || !$CACHE_STATIC_TRANSACT) {
 $sname = sqlslashes($name);
 $skey = sqlslashes($key);
 $sql = "SELECT count(name) AS c FROM systemcache WHERE name = '$sname' AND ckey = '$skey'";
 $rs = query($sql);
 if ($rs["arr"][0]["c"] == 1) {
 $sql = "UPDATE systemcache SET value = '".sqlslashes(serialize($val))."' WHERE name = '$sname' AND ckey = '$skey'";
 query($sql);
 return true;
 } elseif ($rs["arr"][0]["c"] > 1) {
 $sql = "DELETE FROM systemcache WHERE name = '$sname AND ckey = '$skey'";
 query(sqlf_stop($sql));
 $sql = "INSERT INTO systemcache (name,ckey,value) VALUES ('$sname','$skey','".sqlslashes(serialize($val))."')";
 query($sql);
 return false;
 } else {
 $sql = "INSERT INTO systemcache (name,ckey,value) VALUES ('$sname','$skey','".sqlslashes(serialize($val))."')";
 query($sql);
 return false;
 }
 } else {
 return $b;
 }
 }
 return false;
}

function cache_get($name,$key,$static=0) {
 global $CACHE, $CACHE_STATIC, $CACHE_NO_STATIC_CACHE, $CACHE_STATIC_TRANSACT, $CACHE_TMP_CACHE, $CACHE_STATIC_CACHE, $CACHE_STATIC_ACTION, $CACHE_STATIC_RESET;

 if (!$CACHE) return false;
 if (!$name) halt(7, "cache_set: not a valid name. name($name)");
 if (!$key ||is_array($key)) halt(7,"cache_set: not a valid key. key($key)");

 if (!$static) {
 if (!isset($CACHE_TMP_CACHE[$name][$key])) return false;
 else return $CACHE_TMP_CACHE[$name][$key];
 } elseif (!$CACHE_STATIC) {
 if (!isset($CACHE_STATIC_CACHE[$name][$key])) return false;
 else return $CACHE_STATIC_CACHE[$name][$key];
 } else {
 if (!isset($CACHE_STATIC_CACHE[$name][$key]) || $CACHE_NO_STATIC_CACHE) {
 if ($CACHE_STATIC_TRANSACT && !$CACHE_NO_STATIC_CACHE && ((is_array($CACHE_STATIC_RESET) && $CACHE_STATIC_RESET[$name]) || (!is_array($CACHE_STATIC_RESET) && $CACHE_STATIC_RESET) || $CACHE_STATIC_ACTION[$name][$key] == 2)) {
 return false;
 }
 $sql = "SELECT value FROM systemcache WHERE name = '".sqlslashes($name)."' AND ckey = '".sqlslashes($key)."'";
 $rs = query($sql);
 if ($rs["num"] == 1) {
 $val = unserialize($rs["arr"][0]["value"]);
 if (!$CACHE_NO_STATIC_CACHE) {
 $CACHE_STATIC_CACHE[$name][$key] = $val;
 }
 return $val;
 } elseif ($rs["num"] > 1) {
 warning(20,"cache_get: multiple values for name($name), key($key)");
 return false;
 } else {
 return false;
 }
 } elseif (isset($CACHE_STATIC_CACHE[$name][$key])) {
 return $CACHE_STATIC_CACHE[$name][$key];
 } else {
 return false;
 }
 }
 return false;
}

function cache_clear($name,$key,$static=0) {
 global $CACHE, $CACHE_STATIC, $CACHE_NO_STATIC_CACHE, $CACHE_STATIC_TRANSACT, $CACHE_TMP_CACHE, $CACHE_STATIC_CACHE, $CACHE_STATIC_ACTION, $CACHE_STATIC_RESET;

 if (!$CACHE) return false;
 if (!$name) halt(7, "cache_set: not a valid name. name($name)");
 if (!$key ||is_array($key)) halt(7,"cache_set: not a valid key. key($key)");

 if (!$static) {
 unset($CACHE_TMP_CACHE[$name][$key]);
 return false;
 } elseif (!$CACHE_STATIC) {
 unset($CACHE_STATIC_CACHE[$name][$key]);
 return false;
 } else {
 unset($CACHE_STATIC_CACHE[$name][$key]);
 if (!$CACHE_NO_STATIC_CACHE && $CACHE_STATIC_TRANSACT) {
 $CACHE_STATIC_ACTION[$name][$key] = 2;
 } else {
 $sql = "DELETE FROM systemcache WHERE name = '".sqlslashes($name)."' AND ckey = '".sqlslashes($key)."'";
 query($sql);
 }
 return false;
 }
 return false;
}

function cache_reset($name="",$static=0) {
 global $CACHE, $CACHE_STATIC, $CACHE_NO_STATIC_CACHE, $CACHE_STATIC_TRANSACT, $CACHE_TMP_CACHE, $CACHE_STATIC_CACHE, $CACHE_STATIC_ACTION, $CACHE_STATIC_RESET;

 if (!$CACHE) return false;

 if (!$static) {
 if ($name) {
 unset($CACHE_TMP_CACHE[$name]);
 } else {
 unset($CACHE_TMP_CACHE);
 }
 } elseif (!$CACHE_STATIC) {
 if ($name) {
 unset($CACHE_STATIC_CACHE[$name]);
 } else {
 unset($CACHE_STATIC_CACHE);
 }
 } else {

 }
}

function cache_commit($name="") {
 global $CACHE, $CACHE_STATIC, $CACHE_NO_STATIC_CACHE, $CACHE_STATIC_TRANSACT, $CACHE_TMP_CACHE, $CACHE_STATIC_CACHE, $CACHE_STATIC_ACTION, $CACHE_STATIC_RESET;

 if (!$CACHE || !$CACHE_STATIC || $CACHE_NO_STATIC_CACHE || !$CACHE_STATIC_TRANSACT) return false;

}

function cache_rollback($name="") {
 global $CACHE, $CACHE_STATIC, $CACHE_NO_STATIC_CACHE, $CACHE_STATIC_TRANSACT, $CACHE_TMP_CACHE, $CACHE_STATIC_CACHE, $CACHE_STATIC_ACTION, $CACHE_STATIC_RESET;

 if (!$CACHE || !$CACHE_STATIC || $CACHE_NO_STATIC_CACHE || !$CACHE_STATIC_TRANSACT) return false;

}

?>
