<?php





function generateBacktrace() {
 $backtrace = "";
 foreach(debug_backtrace() as $line) {
 if($line["function"] != "halt" && $line["function"] != "warning" && $line["function"] != "generatebacktrace") {
 $backtrace .= $line["function"]." (".$line["file"].":".$line["line"].") <br/>\n";
 }
 }
 return $backtrace;
}










function warning($halt_id = 20, $detail="") {

 global $HALT, $DEBUG, $USER_ID, $PHP_SELF, $QUERY_STRING, $HALT_MSG, $SID, $DO, $JS, $NODEFILE, $RUNLEVEL;

 $o_halt_msg = $HALT_MSG[$halt_id];
 $o_halt_id = $halt_id;

 
 if (empty($o_halt_msg)) {
 $o_halt_msg = $HALT_MSG[0];
 }

 
 if (empty($USER_ID)) $USER_ID=-1;

 
 if ($DEBUG["backtrace"]) $detail .= "<br/>\n".generateBacktrace();
 
 $details = sqlslashes($detail);
 $sql = "INSERT INTO logerror (sid, user_id, halt_id, request, errordo, timestamp, detail) VALUES ('".sqlslashes($SID)."', ".intval($USER_ID).", ".intval($halt_id).", '".sqlslashes($QUERY_STRING)."', ".intval($DO).", ".intval(time()).", '".$details."')";
 if (function_exists("query")) $rs = query($sql);
 else severehalt($halt_id,$detail);
 if (!$rs) severehalt($halt_id,$detail);
 $log_id = $rs["iid"];

 if ($DEBUG["echo"] && $DEBUG["halt"]) {
 echo "\n<br>file: ".$PHP_SELF."?".$QUERY_STRING."\n";
 echo "<br>do: $DO = ".$NODEFILE[$DO]."\n";
 echo "<br>runlevel: $RUNLEVEL\n";
 echo "<br>user: ".$USER_ID."\n";
 echo "<br>details: ".$detail."\n";
 }

 
 global $RUNLEVEL;
 if (class_exists("baseobject") && $RUNLEVEL > 4) {
 $type = ($HALT)?"Halt":"Warning";
 BaseObject::addDebugMessage("$type ($halt_id): $detail", 
 "file: $PHP_SELF"."?$QUERY_STRING\n".
 "do: $DO = ".$NODFILE[$DO]."\n".
 "runlevel: $RUNLEVEL\n".
 "user: $USER_ID\n".
 "details: $detail");
 }
}















function severehalt($halt_id = 0, $detail = "") {
 global $FILEPATH, $do, $USER_ID, $TIME, $PHP_SELF, $QUERY_STRING;
 $fTime = date("d.m.Y H:i", $TIME );
 @system("echo ".escapeshellarg("$fTime	$TIME	$USER_ID	$do	$halt_id	$detail	$PHP_SELF?$QUERY_STRING")." >> $FILEPATH/log/halt.log");
}

function halt ($halt_id = 0, $detail="") {

 global $TPL, $DEBUG, $USER_ID, $PHP_SELF, $QUERY_STRING, $HALT_MSG, $SID, $DO, $HALT, $JS, $NODEPATH, 
 $NODEFILE, $INCLUDE_CHECKED, $NODEMENU, $HTML_NODE_BODY; 
 global $SETMENU, $MENU_LAYER, $HTML_HEADER, $RUNLEVEL;

 
 if (!$HALT) {
 $HALT = true;
 warning($halt_id,$detail);
 mysession_var_write($SID);
 } else {
 severehalt($halt_id,$detail);
 return false;
 }


 
 
 if (!$DEBUG["bug"]) {
 if ($RUNLEVEL >= 4 && class_exists("guifactory") && GUIFactory::isInitialized()) {
 $main =& GUIFactory::getMainGUI();
 $main->printHaltPage($halt_id, $detail);
 } else {
 if (function_exists("generate_menujs") && !$INCLUDE_CHECKED["menu"] && $MENU_LAYER && ($HTML_HEADER || $SETMENU)) { 
 generate_menujs();
 }
 echo $HTML_NODE_BODY;
 include("$NODEPATH/modules/system/template/$TPL/halt.php");
 }
 die(1);
 } else {
 global $cmd, $HI, $ICO_BUG, $LOGERROR_ID;
 $cmd = "new";
 switch ( $halt_id )
 {
 case 3: 
 $DO = 900;
 break;
 default:
 $DO = 806;
 }
 
 global $INCLUDE,$INC,$INCLUDE_LOADED,$INC_COUNT,$COLOR;
 include("$NODEPATH/include/include.inc.php");
 include("$NODEPATH/modules/system/core/bug.php");

 echo html_header();
 $LOGERROR_ID = $log_id;
 
 $CRASH = true;
 
 include("$NODEPATH/modules/system/template/$TPL/bug.php");
 echo html_footer();
 die(1);
 }
}

?>
