<?php

function construct_del($item_id) {

 global $W_DEL,$T_CONSTRUCT, $USER_ID, $T_DOMAIN, $ERROR, $JAVAPARSER_RETURN;

 $ignore_user_abort = ignore_user_abort(true);

 if (!(is_array($item_id))) halt(7,"no construct_id array to delete: item_id($item_id)");

 while (list($id,$val) = each($item_id)) {

 
 

 
 $sql = "SELECT folder_id FROM construct_node, node WHERE construct_id = ".sqlf_tl_num($id)." AND construct_node.node_id = node.id";
 $rs = query($sql);
 $editable = true;
 if (is_array($rs["arr"]))
 while (list($key,$val) = each($rs["arr"])) {
 if (!perm($USER_ID, $T_DOMAIN, $val["folder_id"], 20)) $editable = false;
 }
 else $editable = false;
 if (!$editable) break;

 $javaParser =& CodeParser::getJavaParser();
 $ERROR = $javaParser->deleteObject(T_CONSTRUCT, $id);
 if (!empty($ERROR)) {
 $error = true;
 if (isset($JAVAPARSER_RETURN["params"]["halt"])) {
 halt(7, $ERROR);
 }
 }
 }

 ignore_user_abort($ignore_user_abort);
}

function construct_copy($ids) {

 global $USER_ID, $TIME;
 
 if (!(is_array($ids))) halt(7,"no construct_id array to copy: item_id($ids)");
 
 foreach($ids as $id=>$val) {
 
 if ($id == 1 || !$val) continue;

 $sql = "SELECT * FROM construct WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);

 $row = $rs["arr"][0];
 
 if (!$row) continue;

 $sql = "SELECT language.id, dicuser.value FROM language, dicuser WHERE language.id = dicuser.language_id AND dicuser.output_id = ".sqlf_tl_num($row["name_id"]);
 $rs = query($sql);
 $lang = $rs["arr"];
 
 $sql = "INSERT INTO outputuser (info) VALUES (6)";
 $rs1 = query($sql);
 $name_id = $rs1["iid"];
 
 foreach ($lang as $l) {

 $i = 1;
 while (true) {
 $newName = i18n_lang( $i == 1 ? "Copy of {1}" : "Copy {0} of {1}", 0, $l["id"], array( 0=>$i, 1=>$l["value"] ) );
 
 $sql = "SELECT dicuser.output_id FROM dicuser, construct WHERE construct.name_id = dicuser.output_id AND dicuser.language_id = ".sqlf_tl_num($l["id"])." AND dicuser.value = \"".sqlslashes($newName)."\"";
 $rs = query($sql);
 if ($rs["num"] == 0) break;
 $i++;
 }
 
 $val = $newName;
 
 $sql = "INSERT INTO dicuser (language_id, output_id, value) VALUES (".sqlf_tl_num($l["id"]).", ".sqlf_tl_num($name_id).", \"".sqlslashes($val)."\")";
 query($sql);
 }
 
 $orig_keyword = $row["keyword"];
 $i = 1;
 while (true) {
 $sql = "SELECT id FROM construct WHERE keyword = \"".sqlslashes($orig_keyword.$i)."\"";
 $rs = query($sql);
 if ($rs["num"] == 0) break;
 $i++;
 }
 
 $keyword = $orig_keyword . $i;
 
 $desc_id = word_copy($row["description_id"]);
 $childable = $row["childable"];
 $intext = $row["intext"];
 $autoenable = $row["autoenable"];
 $icon = $row["icon"];
 $category_id = $row["category_id"];
 if( !$category_id ) $category_id = 'NULL';
 
 $sql = "INSERT INTO construct (name_id, description_id, keyword, childable, intext, icon, autoenable, creator, cdate, editor, edate, category_id) VALUES
		 (".sqlf_tl_num($name_id).", ".sqlf_tl_num($desc_id).", \"".sqlslashes($keyword)."\", ".sqlf_tl_num($childable).", ".sqlf_tl_num($intext).", \"".sqlslashes($icon)."\", ".sqlf_tl_num($autoenable).", ".sqlf_tl_num($USER_ID).", ".sqlf_tl_num($TIME).", ".sqlf_tl_num($USER_ID).", ".sqlf_tl_num($TIME).", ".sqlf_tl_num($category_id)." )";

 $rs = query($sql);
 $new_id = $rs["iid"];
 
 $sql = "SELECT node_id FROM construct_node WHERE construct_id = ".sqlf_tl_num($id);
 $rs = query($sql);

 $nodes = "";
 foreach ($rs["arr"] as $row) {
 if ($nodes) $nodes .= ",";
 $nodes .= "(".sqlf_tl_num($row["node_id"]).",".sqlf_tl_num($new_id).")";
 }
 
 if ($nodes) {
 $sql = "INSERT INTO construct_node (node_id, construct_id) VALUES $nodes";
 query($sql);
 }

 $sql = "SELECT * FROM part WHERE construct_id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $parts = $rs["arr"];
 
 foreach ($parts as $r) {
 $name_id = word_copy($r["name_id"]);

 $sql = "INSERT INTO part (name_id, construct_id, type_id, required, editable, partoption_id, partorder, keyword, hidden, ml_id, info_int, 
			  info_text) VALUES (".sqlf_tl_num($name_id).", ".sqlf_tl_num($new_id).", ".sqlf_tl_num($r["type_id"]).", ".sqlf_tl_num($r["required"]).", ".sqlf_tl_num($r["editable"]).", ".sqlf_tl_num($r["partoption_id"]).", 
			  ".sqlf_tl_num($r["partorder"]).", \"".sqlslashes($r["keyword"])."\", ".sqlf_tl_num($r["hidden"]).", ".sqlf_tl_num($r["ml_id"]).", ".sqlf_tl_num($r["info_int"]).", 
			  \"".sqlslashes($r["info_text"])."\")";
 $rs = query($sql);

 $part_id = $rs["iid"];
 
 $sql = "SELECT * FROM value WHERE part_id = ".sqlf_tl_num($r["id"])." AND templatetag_id = 0 AND contenttag_id = 0 AND objtag_id = 0";
 $rs = query($sql);
 
 if (!$rs["arr"]) continue;
 
 $v = $rs["arr"][0];
 
 if ($r["type_id"] == 32) {
 $sql = "SELECT * FROM datasource WHERE id = ".sqlf_tl_num($v["value_ref"]);
 $rs = query($sql);
 $d = $rs["arr"][0];
 
 if ($d) {
 $sql = "INSERT INTO datasource (source_type, name, param_id) VALUES (".sqlf_tl_num($d["source_type"]).", \"".sqlf_escaped($d["name"])."\", ".sqlf_tl_num($d["param_id"]).")";
 $rs = query($sql);
 $dsid = $rs["iid"];
 
 $sql = "SELECT * FROM datasource_value WHERE datasource_id = ".sqlf_tl_num($v["value_ref"]);
 $rs = query($sql);

 foreach ($rs["arr"] as $dv) {
 $sql = "INSERT INTO datasource_value (datasource_id, sorder, dskey, value, dsid) VALUES (".sqlf_tl_num($dsid).", ".sqlf_tl_num($dv["sorder"]).", 
						  \"".sqlf_escaped($dv["dskey"])."\", \"".sqlf_escaped($dv["value"])."\", ".sqlf_tl_num($dv["dsid"]).")";
 query($sql);
 }
 
 $v["value_ref"] = $dsid;
 }
 }
 
 $sql = "INSERT INTO value (part_id, info, static, templatetag_id, contenttag_id, objtag_id, value_text, value_ref) VALUES 
			  (".sqlf_tl_num($part_id).", ".sqlf_tl_num($v["info"]).", ".sqlf_tl_num($v["static"]).", 0, 0, 0, \"".sqlslashes($v["value_text"])."\", ".sqlf_tl_num($v["value_ref"]).")";
 query($sql);
 }
 }
}

function construct_fill($parts,$cid) {
 $rs_fill = tag_fill($parts,$cid,0,"construct");
 return $rs_fill;
}

function construct_partdel($pid) {
 global $W_DEL, $T_CONSTRUCT;

 if (!(is_numeric($pid))) halt(7,"construct_partdel: pid is not int: pid($pid)");

 query("DELETE part, value, value_nodeversion, dicuser, outputuser"
 . " FROM part"
 . " LEFT JOIN value on value.part_id = part.id"
 . " LEFT JOIN value_nodeversion on value_nodeversion.part_id = part.id"
 . " LEFT JOIN dicuser ON dicuser.output_id = part.name_id"
 . " LEFT JOIN outputuser ON outputuser.id = part.name_id"
 . " WHERE part.id = ".sqlf_tl_num($pid));

 logcmd($W_DEL, $T_CONSTRUCT, $pid , 0, "construct_partdel");
}



function cmd_construct_create($name,$keyword,$childable,$intext,$desc,$icon,$autoenable=0,$category=NULL,$hopedithook=NULL,$liveeditortagname=NULL) {

 global $TIME, $USER_ID, $ERROR, $DIC, $W_CREATE, $T_CONSTRUCT, $FEATURE;
 

 if ($liveeditortagname == -9999) {
 $liveeditortagname = null;
 }

 $name_id = word($name,6);
 $desc_id = word($desc,6);
 $childable = ($childable)?"1":"0";
 $intext = ($intext)?"1":"0";
 $a_keyword = sqlslashes($keyword);
 $a_autoenable = $autoenable?1:0;
 if ($keyword) {
 $sql = "SELECT count(id) AS c FROM construct WHERE keyword = '$a_keyword'";
 $rs = query($sql);
 if ($rs["arr"][0]["c"] > 0) {
 $ERROR["keyword"] = i18n('a_tag_with_this_keyword');
 return false;
 }
 }

 
 if ($FEATURE['liveedit_tag_perconstruct']) {
 $liveedit_sql = ",liveeditortagname";
 $liveedit_value = ", '".sqlslashes($liveeditortagname)."'";
 }
 $sql = "INSERT INTO construct (name_id,description_id,keyword,childable,intext,icon,cdate,edate,editor,creator,autoenable,category_id,hopedithook $liveedit_sql) 
VALUES (".sqlf_tl_num($name_id).",".sqlf_tl_num($desc_id).",'$a_keyword',".sqlf_tl_num($childable).",".sqlf_tl_num($intext).",'".sqlf_escaped($icon)."',".sqlf_tl_num($TIME).",".sqlf_tl_num($TIME).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($a_autoenable).",".($category === NULL ? "NULL" : sqlf_tl_num($category)) . ",'".sqlslashes($hopedithook)."' $liveedit_value)";
 $rs = query($sql);
 $cid = $rs["iid"];

 logcmd($W_CREATE, $T_CONSTRUCT, $cid , 0, "cmd_construct_create");
 triggerEvent( T_CONSTRUCT, $cid, EVENT_CREATE, new EventObject() );
 
 return $cid;
}

function cmd_construct_update($id,$name,$keyword,$childable,$intext,$desc,$icon,$autoenable=0,$category=NULL,$hopedithook=NULL,$liveeditortagname=NULL) {

 global $TIME, $USER_ID, $ERROR, $W_EDIT, $T_CONSTRUCT, $DIC, $FEATURE;
 

 if ($liveeditortagname == -9999) {
 $liveeditortagname = null;
 }

 $sql = "SELECT name_id, description_id FROM construct WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $name_id = $rs["arr"][0]["name_id"];
 $desc_id = $rs["arr"][0]["description_id"];
 word($name,6,$name_id);
 word($desc,6,$desc_id);
 $childable = ($childable)?"1":"0";
 $intext = ($intext)?"1":"0";
 $a_keyword = sqlslashes($keyword);
 $a_autoenable = $autoenable?1:0;
 if ($keyword) {
 $sql = "SELECT count(id) AS c FROM construct WHERE keyword = '$a_keyword' AND id != ".sqlf_tl_num($id);
 $rs = query($sql);
 if ($rs["arr"][0]["c"] > 0) {
 $ERROR["keyword"] = i18n('a_tag_with_this_keyword');
 return false;
 }
 }

 if ($FEATURE['liveedit_tag_perconstruct']) {
 $liveedit_sql = ",liveeditortagname='".sqlslashes($liveeditortagname)."'";
 }

 $sql = "UPDATE construct set keyword='$a_keyword',childable=".sqlf_tl_num($childable).",intext=".sqlf_tl_num($intext).",icon='".sqlf_escaped($icon)."',edate=".sqlf_tl_num($TIME).",editor=".sqlf_tl_num($USER_ID).",autoenable=".sqlf_tl_num($a_autoenable).",category_id=".($category === NULL ? "NULL" : sqlf_tl_num($category)) . ",hopedithook='".sqlslashes($hopedithook)."' $liveedit_sql WHERE id = ".sqlf_tl_num($id); 
 $rs = query($sql);
 logcmd($W_EDIT, $T_CONSTRUCT, $id , 0, "cmd_construct_update");
 triggerEvent( T_CONSTRUCT, $id, EVENT_UPDATE, new EventObject() );
 return $id;
}







function cmd_construct_touch($construct_id) {
 global $TIME, $USER_ID;
 $sql = "UPDATE construct SET edate = ".sqlf_tl_num($TIME).", editor = ".sqlf_tl_num($USER_ID)." WHERE id = ".sqlf_tl_num($construct_id);
 query($sql);
 
 
 
 triggerEvent(T_CONSTRUCT, $construct_id, EVENT_CN_CONTENT | EVENT_UPDATE, new EventObject());
}

function cmd_construct_node($construct_id, $construct_node) {

 global $ERROR, $DIC, $W_EDIT, $T_CONSTRUCT;

 if (!$construct_id) return false;

 $changed = false;
 if (is_array($construct_node)) {
 
 
 
 
 
 
 $deletedFromNodes = array();
 
 while (list($key,$val) = each($construct_node)) {
 if ($val) {
 $sql = "SELECT count(construct_id) AS c FROM construct_node WHERE construct_id = ".sqlf_tl_num($construct_id)." AND node_id = ".sqlf_tl_num($key);
 $rs = query($sql);
 if ($rs["arr"][0]["c"] == 0) {
 $sql = "INSERT INTO construct_node (construct_id, node_id) VALUES (".sqlf_tl_num($construct_id).", ".sqlf_tl_num($key).")";
 query($sql);
 
 logcmd($W_EDIT, $T_CONSTRUCT, $key , $construct_id, "cmd_construct_node: link");
 $changed = true;
 }
 } else {
 $sql = "DELETE FROM construct_node WHERE node_id = ".sqlf_tl_num($key)." AND construct_id = ".sqlf_tl_num($construct_id);
 query($sql);
 
 logcmd($W_EDIT, $T_CONSTRUCT, $key , $construct_id, "cmd_construct_node: remove");
 $changed = true;
 
 $deletedFromNodes[] = $key;
 }
 }
 }

 if ($changed) {
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($T_CONSTRUCT, $construct_id);
 }

 $sql = "SELECT count(*) AS c FROM construct_node WHERE construct_id = ".sqlf_tl_num($construct_id);
 $rs = query($sql);
 if ($rs["arr"][0]["c"] == 0) {

 $ERROR = array("cancel"=>(i18n("cn_tagtypes_minnodecount")));
 
 
 foreach ($deletedFromNodes as &$node) {
 $sql = "INSERT INTO construct_node (construct_id, node_id) VALUES (".sqlf_tl_num($construct_id).", ".sqlf_tl_num($node).")";
 query($sql);
 }
 
 return false;
 } 

 return $construct_id;
}

function cmd_part_create($cid,$name,$keyword,$required,$editable,$type_id,$order, $hidden, $ml_id, $inline=0, $info_int=0, $info_text="", $policy = "") {

 
 global $W_CREATE, $W_EDIT, $T_PART, $T_CONSTRUCT, $ERROR;

 $order = (int)$order;

 
 $sql = "SELECT count(*) c FROM part WHERE construct_id = ".sqlf_tl_num($cid)." AND partorder = ".sqlf_tl_num($order);
 $rs = query($sql);
 if ($rs["arr"][0]["c"] > 0) {
 $ERROR = array("porder" => i18n("The Order of the parts must be unique"));
 return false;
 }

 $name_id = word($name,6);
 $editable = ($editable)?"1":"0";
 $required = ($required)?"1":"0";
 $hidden = ($hidden)?"1":"0";
 $inline = ($inline)?"1":"0";
 $ml_id = ($ml_id <= 0)?"0":$ml_id;

 if ($inline) $editable = "2";
 
 $a_keyword = sqlslashes($keyword);
 $a_infotext = sqlslashes($info_text);

 $sql = "INSERT INTO part (construct_id ,name_id,keyword,required,editable,type_id,partorder,hidden,ml_id,info_int,info_text,policy) 
VALUES (".sqlf_tl_num($cid).",".sqlf_tl_num($name_id).",'$a_keyword',".sqlf_tl_num($required).",".sqlf_tl_num($editable).",".sqlf_tl_num($type_id).",".sqlf_tl_num($order).",".sqlf_tl_num($hidden).",".sqlf_tl_num($ml_id).",".sqlf_tl_num($info_int).",'$a_infotext', ".sql_str($policy).")";
 $rs = query($sql);
 $pid = $rs["iid"];

 
 cmd_construct_touch($cid);
 logcmd($W_CREATE, $T_PART, $pid , 0, "cmd_part_create: name($name)");
 logcmd($W_EDIT, $T_CONSTRUCT, $cid , $pid, "cmd_construct_update (new part $name)");

 return $pid;
}







function copyvaluesforpart($part_id, $type) {
 $type = sqlf_table($type);
 $sql = "select $type.id as tag_id, part.id as part_id from part inner join $type on $type.construct_id = part.construct_id left join value on value.${type}_id = $type.id and value.part_id = part.id where part.id = ".sqlf_tl_num($part_id)." and part.editable = 1 and value.id is null and $type.enabled = 1 and exists (select v2.id from value as v2 where v2.part_id = part.id and templatetag_id = 0 and contenttag_id = 0 and globaltag_id = 0 and objtag_id = 0)";
 $rs = query( $sql );
 foreach( $rs['arr'] as $row ) {
 $sql = "INSERT INTO value (part_id,info,static,".$type."_id, value_text, value_ref) SELECT part_id, info, 0, " . sqlf_tl_num($row['tag_id']) . ", value_text, value_ref FROM value where part_id = " . sqlf_tl_num($row['part_id']) . " and templatetag_id = 0 and contenttag_id = 0 and globaltag_id = 0 and objtag_id = 0 limit 1";
 $insertrs = query( $sql );
 }
}

function cmd_part_update($id,$name,$keyword,$required,$editable,$type_id,$order,$hidden,$ml_id,$inline, $info_int=0, $info_text="", $policy = "") {

 
 global $W_EDIT, $T_PART, $T_CONSTRUCT, $ERROR;

 $sql = "SELECT construct_id, editable FROM part WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $cid = $rs["arr"][0]["construct_id"];
 $old_editable = $rs["arr"][0]["editable"];

 
 $sql = "SELECT count(*) c FROM part WHERE construct_id = ".sqlf_tl_num($cid)." AND partorder = ".sqlf_tl_num($order)." AND id != ".sqlf_tl_num($id);
 $rs = query($sql);
 if ($rs["arr"][0]["c"] > 0) {
 $ERROR = array("porder" => i18n("The Order of the parts must be unique"));
 return false;
 }

 $sql = "SELECT name_id FROM part WHERE id = ".sqlf_tl_num($id);
 $rs = query( $sql );
 $name_id = $rs['arr'][0]['name_id'];

 $name_id = word($name,6, $name_id);
 $editable = ($editable)?"1":"0";
 $required = ($required)?"1":"0";
 $hidden = ($hidden)?"1":"0";
 $inline = ($inline)?"1":"0";
 $ml_id = ($ml_id <= 0) ? "0" : $ml_id;

 if ($inline) $editable = "2";

 $a_keyword = sqlslashes($keyword);
 $a_infotext = sqlslashes($info_text);

 $sql = "UPDATE part set name_id=".sqlf_tl_num($name_id).",keyword='$a_keyword',required=".sqlf_tl_num($required).",editable=".sqlf_tl_num($editable).",".
 "type_id=".sqlf_tl_num($type_id).",partorder=".sqlf_tl_num($order).",ml_id=".sqlf_tl_num($ml_id).",hidden=".sqlf_tl_num($hidden).", ".
 "info_int=".sqlf_tl_num($info_int).", info_text='$a_infotext', policy = ".sql_str($policy)." ".
 "WHERE id = ".sqlf_tl_num($id); 
 $rs = query($sql);

 
 $sql = "SELECT id FROM part WHERE construct_id = ".sqlf_tl_num($cid)." AND editable = 0";
 $rs = query($sql);
 if ($rs["num"] > 0) {
 while (list($key,$val) = each($rs["arr"])) {
 $sql = "DELETE FROM value WHERE (contenttag_id != 0 OR templatetag_id != 0 OR globaltag_id != 0 OR objtag_id != 0) AND part_id = ".sqlf_tl_num($val["id"]);
 query($sql);
 }
 }
 
 if($editable==0) {
 $sql = "UPDATE value SET static=1 WHERE contenttag_id=0 AND templatetag_id=0 AND globaltag_id=0 AND objtag_id=0 and part_id = ".sqlf_tl_num($id);
 query($sql);
 }
 if($editable>0) {
 $sql = "UPDATE value SET static=0 WHERE contenttag_id=0 AND templatetag_id=0 AND globaltag_id=0 AND objtag_id=0 and part_id = ".sqlf_tl_num($id);
 query($sql);
 copyvaluesforpart($id,'contenttag');
 copyvaluesforpart($id,'objtag');
 copyvaluesforpart($id,'templatetag');
 }

 $editablelog = "";
 if ($editable != $old_editable) {
 $editablelog = ", editable $old_editable -> $editable";
 }

 
 cmd_construct_touch($cid);
 logcmd($W_EDIT, $T_PART, $id , 0, "cmd_part_update: name($name)$editablelog");
 logcmd($W_EDIT, $T_CONSTRUCT, $cid , $id, "cmd_construct_update (update part $name)");

 return $id;
}









function cmd_part_del($id, &$errorMessage = "")
{
 
 if (empty($id)) {
 halt(0, "cmd_part_del: No part_id to delete");
 }

 $sql = "SELECT construct_id FROM part WHERE id='" . sqlf_tl_num($id) . "'";
 $resultSet = query($sql);

 if (empty($resultSet['arr'])) {
 halt(0, "cmd_part_del: Part was not found in the database");
 }

 $constructId = $resultSet['arr'][0]['construct_id'];

 
 $url = $GLOBALS['CN_LOCAL_SERVER'] . $GLOBALS['PORTLETAPP_PREFIX_INTERNAL']
 . "rest/construct/delete/" . $constructId . "/" . $id;

 $url .= "?" . http_build_query(
 array('sid' => $GLOBALS['SESSION_TOKEN'])
 );

 $fetchCurl = new fetchCurl();
 $fetchCurl->setSubmitType("POST");
 
 
 $fetchCurl->setHeader("Content-Type", "application/json");
 $fetchCurl->setUrl($url);

 $responseBody = $fetchCurl->doRequest();

 
 $returnCode = $fetchCurl->getReturnCode();
 if (empty($returnCode)) {
 halt(7,'Unable to connect to CNPortletapp for getting list data via {' . $url . '}');
 } else if ($returnCode >= 400) {
 halt(120, 'Accessing CNPortletapp returned error ' . $fetchCurl->getReturnCode() . ' for URL {' . $url . '}');
 }

 $response = json_decode($responseBody, true);

 if ($response['responseInfo']['responseCode'] !== "OK") {
 $messages = $response['messages'];
 foreach ($messages as $message) {
 $errorMessage .= $message['message'] . "\n";
 }

 return false;
 }

 return true;
}
