<?php






GUIFactory::setMainGUI("shell");
if( !in_array( $_SERVER['REMOTE_ADDR'], $CN_CONFIG_ALLOWEDIPS ) && $CN_CONFIG_ALLOWEDIPS !== 'ALL - YES, I know what I do !!') {
 halt(7, 'IP Address is not allowed to fetch configuration: ' . $_SERVER['REMOTE_ADDR'] );
}

if ($FEATURE["xnl"]) {
 switch($type) {
 case "10002":
 node_class("cnfolderobject");
 $baseObj = new CNFolderObject($id);
 break;
 case "10008":
 case "10011":
 node_class("cnfileobject");
 $baseObj = new CNFileObject($id);
 break;
 case "10007":
 default:
 node_class("cnpageobject");
 $baseObj = new CNPageObject($id);
 break;
 }

 $xnlParser = &ParserFactory::getInstanceOf("xnl");

 $live = $mode == "live";
 if ($mode == "preview" || $mode == "live" || $mode == "edit") {
 $xnlParser->setShowErrors(!$live);
 $xnlParser->setEvaluate($mode != "edit" ? true : false);
 $xnlParser->setBaseObject($baseObj);
 $xnlParser->setHandleDependencies(false);
 $xnlFuncParser =& $xnlParser->getObjectParser( "func" );
 $xnlFuncParser->addParam( "gti_is_dynamic", "1" );
 $xnlFuncParser->addParam( "gti_session_id", $SESSION_TOKEN );
 
 $xnlParser->clearEventMap();
 $xnlFuncParser =& $xnlParser->getObjectParser( "func" );
 $xnlFuncParser->addParam( "gti_is_dynamic", "1" );
 $xnlFuncParser->addParam( "gti_session_id", $SESSION_TOKEN );

 $source = $xnlParser->parse($source);
 }

 if ($mode == "publish") {
 $xnlParser->setShowErrors(true);
 $xnlParser->setEvaluate(true);
 
 $xnlParser->setBaseObject($baseObj);
 $xnlParser->setHandleDependencies(true);
 $xnlParser->clearEventMap();

 $source = $xnlParser->parse($source);

 static $repubFuncs = false;
 if ($repubFuncs === false) {
 $repubFuncs = array();
 $request =& $xnlParser->getRequestor();
 $funcs = $request->getFunctions();
 foreach ($funcs as $func) {
 if ($request->getFuncNeedsRepublish($func)) $repubFuncs[] = $func;
 }
 }
 
 $skip_status = false;
 foreach ($repubFuncs as $func) {
 
 if (($pos = strrpos($func, ".")) !== false) {
 $funcName = substr($func, $pos + 1);
 $funcTags = $xnlParser->findParserTags("function", $funcName, true);
 if (count($funcTags)) {
 $skip_status = true;
 break;
 }
 }
 $funcTags = $xnlParser->findParserTags("function", $func, true);
 if (count($funcTags)) {
 $skip_status = true;
 break;
 }
 }
 header( "X-Gentics-XNL-Republish: " . (!$skip_status ? 'False' : 'True') );
 }
}
?>
