<?php

node_include ("contentgroup");

function get_pubqueue( $ordered = false ) {
 global $USER_ID, $T_FOLDER, $ICO_PAGE_QUEUE, $FEATURE, $DIC, $PAGE_STATI, $T_PAGE;

$ires = item_order("pname","ASC",array("page.name"=>"pname","folder.name"=>"fname"));

$sql = "SELECT page.id, page.time_pub, page.content_id, page.name AS pname, page.filename, page.priority, page.editor, page.edate, page.creator, page.cdate, page.description, page.status, page.contentgroup_id AS contentgroup, folder.name AS fname, page.channel_id, folder.id AS folder_id ".$ires["select"]." 
FROM page, folder
WHERE page.folder_id = folder.id AND page.status = 4";
if ($ordered) $sql .= $ires["orderby"];

$rs = query($sql);

if (is_array($rs["arr"]))
while (list($key,$val) = each($rs["arr"])) {
 if (perm($USER_ID,$T_FOLDER,$val["folder_id"],19,$val['contentgroup'], $T_PAGE, 14)) {
 $o_queue[$key] = $val;
 $o_queue[$key]["cdate"] = db2date($val["cdate"]);
 $o_queue[$key]["edate"] = db2date($val["edate"]);
 $o_queue[$key]["icon"] = img($ICO_PAGE_QUEUE);
 $o_queue[$key]["links"] = check_links($val["content_id"]);
 $o_queue[$key]["time_pub"] = db2date($val["time_pub"], i18n("LOCALIZED_DATETIMEFORMAT"));

 $editor = get_userinfo($val["editor"]);
 $creator = get_userinfo($val["creator"]);

 $editor_desc = $editor ["lastname"]." ".$editor ["firstname"];
 $creator_desc = $creator["lastname"]." ".$creator["firstname"];

 if ($FEATURE["pubqueue_email"]) {
 if ($editor["email"]) {
 $editor_desc .= " &lt;{$editor['email']}&gt;";
 }
 if ($creator["email"]) {
 $creator_desc .= " &lt;{$creator['email']}&gt;";
 }
 }

 $o_queue[$key]["editor"] = $editor_desc;
 $o_queue[$key]["creator"] = $creator_desc;

 
 $o_queue[$key]["editor_id"] = $editor["id"];
 $o_queue[$key]["creator_id"] = $creator["id"];

 $status = $o_queue[$key]["status"];
 if ($status == 1)
 $status = 2;

 $o_queue[$key]["status"] = i18n($PAGE_STATI[$status]);

 if ($FEATURE["contentgroup3"])
 {
 $cgs = get_contentgroups ();

 if ($o_queue[$key]["contentgroup"])
 {
 $tmp = $o_queue[$key]["contentgroup"];
 $o_queue[$key]["languageass"] = "<br>" . i18n ("language") . ": " . $cgs[$tmp]["code"];
 }
 else
 $o_queue[$key]["languageass"] = "";
 }

 $folder_info = get_folderinfo ($o_queue[$key]["folder_id"]);

 
 if ($o_queue[$key]["channel_id"] != 0) {
 $node_info = get_nodeinfo($o_queue[$key]["channel_id"]);
 } else { 
 $node_info = get_nodeinfo($folder_info["node_id"]);
 }
 
 $o_queue[$key]["node"] = $node_info["name"];
 }
}

return $o_queue;
}

?>
