<?php
function make_link($type,$id,$node_id,$pubway="", $depth=0) {

global $PATH_PAGE, $PATH_FILE, $LINKWAY, $PUBWAY, $FEATURE, $T_PAGE, $T_FILE, $LINKWAY_FILE_PATH, $LINKWAY_FILE, $SKIP_WRITEFS, $STAG;

$pubway = ($pubway)?$pubway:$PUBWAY;
if ($pubway == "real") {
 $pubway = "dyn";
 $realedit = true;
}

if (($type != "page" && $type != "file" && $type != "folder") || !$id) halt(7,"make_link: invalid arguments: type($type) id($id)");

if ($pubway != "dyn" && $pubway != "stat") halt(7, "make_link: invalid pubway($pubway)");
if ($LINKWAY != "host" && $LINKWAY != "abs" && $LINKWAY != "auto" && $LINKWAY != "portal") halt(7, "make_link: invalid LINKWAY($LINKWAY)");

if ($type == "page") {

 $page = get_pageinfo($id);

 if ($FEATURE["managelinkurl"]) {
 if ( !$page ) return "#";
 $sql = "SELECT count(id) AS c FROM publish WHERE page_id = ".sqlf_tl_num($id)." AND active = 1";
 $rs = query($sql,true);
 if ($page["status"] != 1 && $page["status"] != 2 && $rs["arr"][0]["c"] == 0) {
 if ($FEATURE['dsfallback'] && $page["contentset_id"] > 0) {
 
 $sql = "SELECT page.id FROM page, node_contentgroup LEFT JOIN publish ON (publish.page_id = ".sqlf_tl_num($page['id']).") WHERE page.contentset_id = ".sqlf_tl_num($page['contentset_id'])." AND ((page.status = 1 OR page.status = 2) OR (page.status != 1 AND page.status != 2 AND publish.active = 1)) AND node_contentgroup.contentgroup_id = page.contentgroup_id ORDER BY node_contentgroup.sortorder ASC";
 $rs = query($sql,true);
 if ($rs['arr'][0]['id']) {
 $id = $rs['arr'][0]['id'];
 } else {
 return '#';
 }
 } else {
 return "#";
 }
 }
 }

 
 if ($pubway == "dyn") {
 if ($realedit) {
 $tpl = get_templateinfo($page["template_id"]);
 
 if ($tpl["ml_id"] != 9) $tmp = "$STAG&amp;do=14012&amp;real=view&amp;realid=";
 else $tmp = $PATH_PAGE;
 } else $tmp = $PATH_PAGE;
 $val = $tmp.$id;
 }
 
 if ($pubway == "stat") {
 $page = get_pageinfo($id);
 if ( !$page ) return "#";
 if ($page["folder_id"]) {
 $folder = get_folderinfo($page["folder_id"]);
 $node = get_nodeinfo($folder["node_id"]);
 
 if ( !$node["publish_fs"] && $node["publish_contentmap"] && $FEATURE["contentmap"] )
 $linkway = "portal";
 else
 $linkway = $LINKWAY;
 
 if (($linkway == "auto" && $node_id == $folder["node_id"]) || $linkway == "abs") $val = $node["pub_dir"].$folder["pub_dir"].$page["filename"];
 else if (($linkway == "auto" && $node_id != $folder["node_id"]) || $linkway == "host") {
 $val = "http://".$node["host"].$node["pub_dir"].$folder["pub_dir"].$page["filename"];
 } else if ( $linkway == "portal" ) {
 if ( $FEATURE["plink_attributes"] ) {
 global $PLINK_ATTRIBUTES, $TAG_PREFIX;


 foreach ( $PLINK_ATTRIBUTES as $name => $values ) {
 $tagName = $values['tagname'];
 $obj_type = $values['tagobject'];
 $t_type = $values['t_type'];
 
 
 if ( $obj_type == 'content' || $obj_type == 'template' || $obj_type == 'obj' ) {
 $o_type = sqlf_table($obj_type.'tag');
 if ( $obj_type == 'obj' ) {
 if ( $t_type == T_PAGE ) {
 $o_id = $id;
 } else if ( $t_type == T_TEMPLATE ) {
 $o_id = $page['template_id'];
 } else if ( $t_type == T_FOLDER ) {
 $o_id = $page['folder_id'];
 }
 $sql = "SELECT id FROM $o_type WHERE obj_type = '".sqlf_escaped($t_type)."' AND obj_id = '".sqlf_escaped($o_id)."' AND name = '".sqlf_escaped($tagName)."'";
 } else {
 $sql = "SELECT id FROM $o_type WHERE name = '".sqlf_escaped($tagName)."'";
 }
 $prs = query ($sql);
 $po_id = $prs['arr'][0]['id'];
 $tags = obj_translate($po_id, $o_type, $id, 'page', $node_id, false, $depth);
 $tmp = "<$TAG_PREFIX $tagName>";
 $val = code_translate($tmp, $tags, "page", false, array(), "page", 0, false, $node_id);
 } else {
 $val = 'UNKNOWN tagobject ('.$obj_type.') [content|template|obj] IN PLINK_ATTRIBUTES.';
 }
 $plink_attributes .= " $name=\"$val\"";
 }
 }
 $val = "<plink id=\"$T_PAGE.$id\"$plink_attributes />";
 } else halt(7,"make_link: invalid LINKWAY($linkway) and node_id($node_id) and folder[node_id](".$folder["node_id"].")");
 }
 }

}

if ($type == "file") {

 $file = get_fileinfo($id);
 if ($FEATURE["managelinkurl"]) {
 if (!$file["name"]) return "#";
 }

 if ( $file["folder_id"] ) $folder = get_folderinfo($file["folder_id"]);
 if ( $folder["node_id"] ) $node = get_nodeinfo( $folder["node_id"] );
 if ( !$node["publish_fs"] && $node["publish_contentmap"] && $FEATURE["contentmap"] )
 $flinkway = (isset($LINKWAY_FILE))?$LINKWAY_FILE:$LINKWAY;
 else
 $flinkway = $LINKWAY;

 
 if ($pubway == "dyn") $val = $PATH_FILE.$id."&amp;time=".time()."&amp;".$file["name"];
 if ($pubway == "stat") {
 if ($file["folder_id"]) {
 $folder = get_folderinfo($file["folder_id"]);
 $node = get_nodeinfo($folder["node_id"]);
 if (($flinkway == "auto" && $node_id == $folder["node_id"]) || $flinkway == "abs") $val = $node["pub_dir"].$folder["pub_dir"].$file["name"];
 else if (($flinkway == "auto" && $node_id != $folder["node_id"]) || $flinkway == "host") {
 $val = "http://".$node["host"].$node["pub_dir"].$folder["pub_dir"].$file["name"];
 } else if ( $flinkway == "portal" ) {
 $val = "<plink id=\"".CT_FILE.".$id\" />";
 } else if ($flinkway == "dyn") {
 $val = $LINKWAY_FILE_PATH.CT_FILE.".$id&amp;".$file["name"];
 } else halt(7,"make_link: invalid flinkway($flinkway) and node_id($node_id) and folder[node_id](".$folder["node_id"].")");
 }
 }

}

if ($type == "folder") {
 $folder = get_folderinfo($id);
 
 if ($folder["node_id"]) $node = get_nodeinfo($folder["node_id"]);
 if ($pubway == "stat" && (($LINKWAY == "auto" && $folder["node_id"] == $node_id) || $LINKWAY == "abs")) $val = $node["pub_dir"].$folder["pub_dir"];
 else if (($LINKWAY == "auto" && $folder["node_id"] != $node_id) || $LINKWAY == "host" || $LINKWAY == "portal" || $pubway == "dyn") {
 $val = "http://".$node["host"].$node["pub_dir"].$folder["pub_dir"];
 } else halt(7,"make_link: invalid LINKWAY($LINKWAY) and node_id($node_id) and folder[node_id](".$folder["node_id"].")");

}

return $val;

}

?>
