<?php

function msconvert($file, $format_file) {
 global $FILEPATH, $TIME, $SID, $ERROR, $TAG_PREFIX, $TMPPATH, $NODEPATH, $WVWARE_PATH, $FEATURE;

 
 if (!file_exists($WVWARE_PATH)) {
 $ERROR = "Config error: wvWare not avilable under $WVWARE_PATH.";
 return false;
 }
 if (!file_exists($format_file)) {
 $ERROR = "Config error: Formatfile not avilable under $format_file.";
 return false;
 }

 
 $tmp_name = "msword_$TIME";
 $tmp_file = "$TMPPATH/$tmp_name/$tmp_name";

 
 if (!mkdir("$TMPPATH/$tmp_name", 0700)) {
 $ERROR = "Error creating tmp directory $TMPPATH/$tmp_name";
 return false;
 }
 if (!copy($file, $tmp_file.".doc")) {
 $ERROR = "Error coping $file to $tmp_file.doc";
 return false;
 }

 
 if ($FEATURE["msconvert_utf8"]) {
 $res = `$WVWARE_PATH -c UTF-8 -x $format_file $tmp_file.doc > $tmp_file.html\n`;
 } else {
 $res = `$WVWARE_PATH -x $format_file $tmp_file.doc > $tmp_file.html\n`;
 }
 if ($res) {
 $ERROR = "Error while converting: $res";
 



 return false;
 }

 
 if (file_exists($tmp_file.".html")) { 
 $fp = fopen($tmp_file.".html","r");
 $bla = fread($fp, filesize($tmp_file.".html"));
 fclose($fp);
 $bla = str_replace("\n","",$bla);
 
 $offset = 0;
 while ($offset = strpos($bla,"<img width=",$offset)) {
 $end = strpos($bla,">",$offset);
 $_img[] = substr($bla,$offset,$end - $offset + 1);
 $offset = $end;
 }
 
 $images = Array();
 if (is_array($_img))
 while (list($k,$v) = each($_img)) {
 $regex = "<img width=\"([0-9]*)\" height=\"([0-9]*)\" alt=\"(.*)\" src=\"((.*)".addslashes($tmp_file)."([0-9]*).([a-zA-Z]*))\".*";
 ereg ($regex,$v,$data);
 $img_nr = $data[6];
 $images[$img_nr]["width"] = $data[1]; 
 $images[$img_nr]["height"] = $data[2];
 
 $images[$img_nr]["file"] = $data[4]; 
 $images[$img_nr]["path"] = $data[5];
 $images[$img_nr]["ext"] = $data[7];
 $images[$img_nr]["name"] = "msword".$img_nr;
 }
 
 $bla = ereg_replace("<img width=[ a-zA-Z0-9=\"/\._]*".addslashes($tmp_file)."([0-9]*)[ a-zA-Z\"\.]*>","<$TAG_PREFIX msword\\1>",$bla);
 } else {
 $ERROR = "Error while converting: Output was not generated";
 return false;
 }

 

 return array("data"=>$bla,"images"=>$images); 

}

?>
