<?php
GUIFactory::setMainGUI( "main" );

function fetch_wsdl( &$form, $param )
{
 global $ICO_SOAP;
 $tC =& $form->getComponent( "wsdl_url" );
 $soapclient = new GcnSoapClient($tC->getText(),'wsdl');
 $form->setHeader($soapclient->wsdl->serviceName, $ICO_SOAP);
 if (!$form->componentExists('func_list')) {
 $form->addComponent( 'func_list', new WSDLComponent(NULL, $soapclient));
 } else {
 $sC =& $form->getComponent( 'func_list' );
 $sC->setSoapClient($soapclient);
 }
}

function exec_soap_func( &$form, $param )
{
 if ($form->componentExists('func_list')) {
 $func_list = &$form->getComponent( 'func_list' );
 $soapclient = &$func_list->getSoapClient();
 if ($func_name = $func_list->getSelectedFunction() ) {
 $params = $func_list->getFunctionParams();
 $ret = $soapclient->call($func_name, $params);
 }
 }
 if( $err = $soapclient->getError() ){
 $func_list->setResult($err);
 } else {
 
 $func_list->setResult($soapclient->data); 
 $func_list->setResult($soapclient->document); 
 
 }
}

$form = new HtmlForm3( "soap" );
if ( $form->isNew() )
{
 $form->setHeader(i18n("soap"), $ICO_SOAP);
 $form->addComponent( "wsdl_url", new TextComponent( i18n("WSDL"), TRUE, $XNL_SOAP_SERVER_URI.'?wsdl', REG_URL, 50 ) );
 
 $form->addButton( 'fetch', new Button( i18n( "Fetch WSDL" ) ), new SimpleFormAction( "fetch_wsdl" ), TRUE );
 $form->addButton( 'exec', new Button( i18n( "Execute Function" ) ), new SimpleFormAction( "exec_soap_func" ), FALSE );
 $button = &$form->getButton('exec');
 $button->setEnabled(false);

} else {

 if ( $form->componentExists('func_list') ) 
 {
 $wsdl = &$form->getComponent('func_list');
 $button = &$form->getButton('exec');
 if ( $wsdl->getSelectedFunction() ) {
 $button->setEnabled(true);
 } else {
 $button->setEnabled(false);
 }
 }

}


?>
