<?php

node_class("ResultsetFormatter");

class RunDiffFormatter extends ResultsetFormatter
{
 function format( $rs, $param )
 {
 if ( $rs["starttime"] <= 0 || $rs["endtime"] <= 0 ) return "---";
 $diff = $rs["endtime"] - $rs["starttime"];
 return TimeObject::formatTimeDiffHours( $diff );
 }
}

class SystemReturnCodeFormatter extends ResultsetFormatter {
 function format ($rs, $param) {
 global $STAG;
 if (!empty($param["back"])) {
 $add = "&back=".$param["back"];
 }
 if (!$rs["returnvalue"]) $return = "<font color=green>".i18n("OK")."</font>";
 else $return = "<font color=red>".i18n("Failed")."</font>";
 if ($rs["output"]) $return = "<a href=\"$STAG&do=874&id=".$rs["id"]."$add\">$return</a>";
 return $return;
 }
}

?>
